<?php
/******************************************************************
 * NOTE: Do not edit this file unless you know what you are doing *
 ******************************************************************/
/**
 * Base URL used to access your instance of EnterTrack.  You should
 * no longer have to set this manually unless for some reason you run
 * into trouble where it is not set correctly.  If you do need to set
 * it then make sure to include http:// or https:// and the trailing slash.
 */
if (!empty($_SERVER['SCRIPT_URI'])) {
  if (ereg("IIS",$_SERVER['SERVER_SOFTWARE'])) {
    define("_URL_",trunc_after_last_slash($_SERVER['SCRIPT_URI'])."index.php");
  } else {
    define("_URL_", trunc_after_last_slash($_SERVER['SCRIPT_URI']) );
  }
} else {
  if (ereg("IIS",$_SERVER['SERVER_SOFTWARE'])) {
    define("_URL_", (!empty($_SERVER['HTTPS']) ? 'https' : 'http').'://'
      .$_SERVER['HTTP_HOST'].((!empty($_SERVER['SERVER_PORT'])
      and $_SERVER['SERVER_PORT'] != 80) ? ':'.$_SERVER['SERVER_PORT'] : '')
      .trunc_after_last_slash($_SERVER['PHP_SELF'])."index.php");
  } else {
    define("_URL_", (!empty($_SERVER['HTTPS']) ? 'https' : 'http').'://'
      .$_SERVER['HTTP_HOST'].((!empty($_SERVER['SERVER_PORT'])
      and $_SERVER['SERVER_PORT'] != 80) ? ':'.$_SERVER['SERVER_PORT'] : '')
      .trunc_after_last_slash($_SERVER['PHP_SELF']) );
  }
}

function trunc_after_last_slash( $str ) {
    return substr($str,0,strrpos($str,'/') + 1);
}

/**
 * This is the user that file directories and uploaded files
 * will be owned by.
 */
define("_WEBUSR_","nobody");

/**
 * This is the group that file directories and uploaded files
 * will be owned by.
 */
define("_WEBGRP_","nobody");

/**
 * Employees group id, members of this group are granted 
 * additional privileges over normal users
 */
define("_EMPLOYEES_",1);

/**
 * Maximum upload size allowed for normal users
 */
define("_MAXUPLOAD_", 52428800);

/**
 * Status Types
 * These are used to define what each status is used for,
 * such as a closed status, waiting on tech, etc, so that
 * each one does not need to be hard coded.
 */
// XXX These calls will happen before i18n is set up, and thus won't get
// translated :(
global $status_types;
$status_types = array(
  1 => ("Registered"),    // Issue is created
  2 => ("Waiting"),       // Issue is waiting on someone
  3 => ("Long Term"),     // Issue will be long term (not counted in auto closer)
  4 => ("Stale"),         // Issue is stale (not updated in 2 weeks)
  5 => ("Closed"),        // Issue is closed by actual person
  6 => ("Auto Closed")    // Issue is closed by automatic script
);

// Status Type Constants
define("TYPE_REGISTERED",1);
define("TYPE_WAITING",2);
define("TYPE_LONG_TERM",3);
define("TYPE_STALE",4);
define("TYPE_CLOSED",5);
define("TYPE_AUTO_CLOSED",6);

// Severity Constants
define("SEV_URGENT",1);
define("SEV_HIGH",2);
define("SEV_NORMAL",3);
define("SEV_LOW",4);

// Permission Set Constants for default system sets
define("PSET_GADMIN",1);
define("PSET_CLIENT",2);
define("PSET_PCLIENT",3);
define("PSET_SCLIENT",4);
define("PSET_TECH",5);


// Session Handling -- marc@gridshield.net
define ("_MAX_SESSION_LIFETIME_","7200");

// EnterTrack Version Number
define("_VERSION_","EnterTrack 1.2.6");
?>
