<?php
/******************************************************************
 * NOTE: Do not edit this file unless you know what you are doing *
 ******************************************************************/
/**
 * This module specifies paths to the many directories used in
 * EnterTrack.  With the default setup, there is no need to change
 * anything here.  If you move directories, make the corresponding
 * changes here.
 *
 * _PATH_ is automatically defined in initialize.php to the
 * directory containing that file; by default, all other paths
 * are built relative to _PATH_.
 */

/****
 * Smarty
 *
 * Uncomment this and change the path to point to the directory
 * containing Smarty.class.php, *including the trailing slash*.
 * See the online documentation for more details
 */
define("SMARTY_DIR", "/usr/share/php/Smarty/");

/****
 * Shared code paths
 *
 * These directories should *not* be writeable by the web server.
 */

/**
 * Base for shared code
 */
define("_SHARED_CODE_",_PATH_);

/**
 * Location of the includes directory.
 */
define("_INCLUDES_",_SHARED_CODE_."/includes/");

/**
 * Location of the classes directory.(ordinarily under includes/)
 */
define("_CLASSES_",_INCLUDES_."classes/");

/**
 * Location of the subsystems directory (ordinarily under includes/)
 */
define("_SUBSYSTEMS_",_INCLUDES_."subsystems/");

/**
 * Location of the functions directory.
 */
define("_FUNCTIONS_",_INCLUDES_."functions/");

/**
 * Location of the mishoo's "The Coolest DHTML Calendar"
 */
define("_JS_CALENDAR_",_INCLUDES_."js-calendar/");
define("_JS_CALENDAR_URI_","includes/js-calendar/");

/**
 * Location of the modules directory.
 */
define("_MODULES_",_SHARED_CODE_."/modules/");

/**
 * Location of the themes directory.
 */
define("_THEMES_",_SHARED_CODE_."/themes/");

/**
 * The 'locale' directory, containing translations
 */
define("_LOCALE_",_SHARED_CODE_."/locale/");

/**
 * Location of the jpgragh classes.  If this doesn't point to the right place
 * then graph generation will not work correctly.  The JPGRAPH graphing
 * classes are not included with EnterTrack but can be found at 
 * http://www.aditus.nu/jpgraph/
 */
define("_JPGRAPH_",_SHARED_CODE_."/graphing/");

/**
 * Location of help files.  These are plain text or html files
 * that correspond to module actions.  If a file exists for an
 * action then the help link should automatically display.
 */
define("_HELP_",_SHARED_CODE_."/help/");



/****
 * Local State
 *
 * Storage for install-specific data.  These directories *should*
 * be writeable by the web server.
 */

/**
 * Local State
 */
define("_LOCAL_STATE_",_PATH_);

/**
 * Location where css files are generated.  This directory should be
 * web accessible and writeable by your web server.
 */
define("_CSS_",_LOCAL_STATE_."/css/");

/**
 * Location of the cache directory.  This directory is where cache
 * arrays will be stored.  These arrays are used to pull frequently
 * queried information like usernames, statuses, categories, etc.
 * This is done to save the overhead of having to make huge amounts
 * of queries on pages that pull alot of information like group
 * issue listings.
 */
define("_CACHE_",_LOCAL_STATE_."/cache/");

/**
 * Location where graph images will be stored.  Make sure this
 * directory is web accessible.  The default for this is inside
 * the images directory which you should not need to change.
 */
 // NOTE: I swap "image" dir by "cache" dir
define("_GRAPHS_",_CACHE_."graphs/");

/**
 * Smarty's cache directory and two subdirectories.  This directory
 * tree must be writeable by the web server.
 */
define("_TPLCACHE_",_CACHE_."templates/");
define("_TPLCOMPILE_",_TPLCACHE_."compiled/");
define("_TPLCONFIG_",_TPLCACHE_."config/");

/**
 * Location of the logs directory. 
 */
define("_LOGS_",_LOCAL_STATE_."/logs/");

/**
 * Location of sessions directory.  This is where EnterTrack session
 * files will be kept.  Make sure it is writable by the web server user.
 * For security purposes you may want to make this directory not web
 * accessible.  This is only used if $session_handler is set to FALSE.
 */
define("_SESSIONS_",_LOCAL_STATE_."/sessions/");

/**
 * Location where uploaded files will be kept.  This directory must
 * be writable by your webserver, but for security purposes should
 * not be web accessible.  Make sure to include the trailing slash.
 */
define("_FILES_",_LOCAL_STATE_."/var/EnterTrack-files/");
#define("_FILES_","/mnt/nfs/");

?>
