<?php


/**
 * Parameters that can be passed in the http request, or as environment variables if run from command line:
 *
 * 'SECRET' - shared secret from conf/config.php 
 * 'type' or 'report':  the report type
 * 	values:
 * 	'user' or 'assigned-issues' = user based report
 * 	'group' = group based report
 *
 * 'option' - option for user based report type
 * 	values:
 * 	'all' or not specified = report on all open issues for user
 * 	'daily' = report on issues with due-date in next 24 hours
 * 	'weekly' = report on issues with due date in coming week
 *
 * 'uri' - uri, relative to server URL, to add on to links within the user based report
 *
 * 'root' - complete URL to use in links.  This overrides the default link constructon which is based on the HTTPS and SERVER_NAME variables
 * 	found either in the "$_SERVER" array when called from Apache, or the $_ENV array when called from command line, plus the 'uri'
 * 	parameter if it was specified.
 *
 *
 * **/


#ini_set("display_errors",false);
include_once('Mail.php');
include_once('Mail/mime.php');
require_once("initialize.php");
initialize_entertrack("web");

$secret = reqenv("SECRET");  

if ( $secret != $_ENV['config']['email']['shared_secret'])
    die("Shared secrets do not match");

$type = ( reqenv("type") ? reqenv("type") : reqenv("report") );  //report is synonmym for type
$type = ( $type == "assigned-issues" ? "user" : $type);          // assigned issues is synonym for "user" report type


$title = $_ENV['config']['display']['title'];
$sender = $_ENV['config']['email']['sender'];
$company = $_ENV['config']['display']['company'];

$script_out=array();

switch ($type) {
case 'user':
	$option = reqenv("option");
	
	require ("modules/reports/automatic/userIssues.php");
	break;
   case 'group':
	require ("modules/reports/automatic/groupIssues.php");
	break;
   default:
	die ("Invalid report type");
}


$_ENV['tpl']->assign('script_out',$script_out);
$_ENV['tpl']->display("reports/automatic/autoReport.tpl");

function reqenv($name) {
	return ( isset($_REQUEST[$name]) ? $_REQUEST[$name] : $_ENV[$name] );
}

?>
