<?php
if (function_exists("gzopen")) {
  ob_start("ob_gzhandler");
}

header("Content-type: text/css");

define("BROWSER",TRUE);

require_once("initialize.php");
initialize_entertrack('css');

function load_user_settings($themedir, $userid)
{
  if (!$userid) { return array(); }
  return user_preferences();
}

// check GET arguments against the session; we only use the GET so that distinct stylesheets have
// distinct URLs

$theme = 'default';
if (isset($_GET['theme']) && isset($_SESSION['theme']) && $_GET['theme'] == $_SESSION['theme']) {
  $theme = $_SESSION['theme'];
}

$userid = null;
if (isset($_GET['userid']) && isset($_SESSION['userid']) && $_GET['userid'] == $_SESSION['userid']) {
  $userid = $_SESSION['userid'];
}

// Load the theme's code
$themedir = sprintf("%s/%s", _THEMES_, $theme);
if (file_exists("$themedir/css.php")) {
  include("$themedir/css.php");
}

if (file_exists("$themedir/theme.php")) {
  include("$themedir/theme.php"); // updates $theme
}

if (isset($_GET['kind'])) {
  switch ($_GET['kind']) {
    case 'user':
      $theme_defaults = get_theme_settings();
      $user_settings = load_user_settings($themedir, $userid);
      produce_css(user_css(array_merge($theme_defaults, $user_settings)));
      break;

    case 'screen':
      produce_css(screen_css());
      break;

    case 'print':
      produce_css(print_css());
      break;
  }
}
