<?php

/* {{{ Function produce_css */
/**
 * Produce regulation CSS from an array, the keys of which are
 * CSS selectors, and the values of which are further arrays.  In
 * those further arrays, each key/value pair corresponds to a
 * declaration.
 *
 * This function sends the CSS directly to the browser.
 *
 * @param array $rules the rules as described above
 */
function produce_css($rules)
{
  foreach ($rules as $selector => $declarations) {
    echo "$selector {\n";
    foreach ($declarations as $lhs => $rhs) {
      echo "  $lhs: $rhs;\n";
    }
    echo "}\n";
  }
}
