<?php

/* http.php
 *
 * Functions to do funny things with HTTP
 */

/* {{{ Function: redirect */
/**
 * This is just a simple redirect function
 * but it makes sure that the session is written
 * and closed before the redirect happens
 *
 * @param string $url URL to redirect to
 */
function redirect($url = null)
{
  if (empty($url)) {
    $url = _URL_;
  }

  // prepend the full URL if this is a ?-relative link
  // (technically all redirects have to be full URLs, although
  // most browsers will handle root-relative and directory-relative
  // URIs)
  if ($url{0} == '?') {
    $url = _URL_.$url;
  }

  session_write_close();
  header("Location: $url");

  // do not complete processing this page
  exit;
}
?>
