<?php
/* {{{ Function get_user_menu */
/**
 * Takes a userid and returns that user's personal menu
 *
 * @param integer $userid ID of user
 * @return array $menu
 */
function get_user_menu($userid)
{
  $menu = array();

	$sql  = "SELECT text,url ";
	$sql .= "FROM menus ";
	$sql .= "WHERE userid=? ";
  $stmt = $_ENV['dbi']->prepare($sql); 
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
	$result = $stmt->execute(array($userid));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  while (list($text,$url) = $result->fetchRow(MDB2_FETCHMODE_ORDERED)) {
    $menu[$text] = $url;
  }
  $result->free();
  $stmt->free();

	return $menu;
}
/* }}} */
