<?php

/*
 * config.php
 * 
 * This subsystem loads the site configuration and does some basic 
 * sanity-checking.  Configuration is available in the auto-global
 * $_ENV['config'].
 */

function config_err($msg)
{
  echo "<b>Fatal Error</b><br />";
  echo $msg;
  exit;
}

/* {{{ Function config_init */
/**
 * Initialize the configuration.  The context is ignored.
 *
 * @param string $context the context
 */
function config_init($context)
{
  $config = _PATH_."/conf/config.php"; 
  $const = _PATH_."/conf/const.php"; 

  // Load the configs
  include($config);
  include($const);

  // Make sure it came in in the right format; bail out if not.
  if (!isset($_ENV['config']) || !isset($_ENV['config']['db'])) {
    // use a redirect so the browser doesn't cache an error message
    // on the main page.
    header("Location: setup/config_error.php");
    exit;
  }
}
/* }}} */
?>
