<?php

// Load the subsystems files.

require_once(_SUBSYSTEMS_."config.php");
require_once(_SUBSYSTEMS_."error.php");
require_once(_SUBSYSTEMS_."session.php");
require_once(_SUBSYSTEMS_."i18n.php");
require_once(_SUBSYSTEMS_."tpl.php");
require_once(_SUBSYSTEMS_."dbi.php");
require_once(_SUBSYSTEMS_."notif.php");

/* {{{ Function initialize_subsystems */
/**
 * Initialize the subsystems, given a specific context (see
 * initialize_entertrack() in initialize.php)
 *
 * @param string $context the context
 */
function initialize_subsystems($context)
{
  // Initialize the subsystems.  This is order-dependent

  config_init($context);
  dbi_init($context); # pq: config
  error_init_early($context); # pq: config
  session_init($context); # pq: config, dbi, error
  tpl_init($context); # pq: config, session, error
  i18n_init($context); # pq: config, session, tpl, error
  notif_init($context); # pq: i18n

  // finish up error initialization
  error_init_late($context);
}
/* }}} */

?>
