<?php

/*
 * email.php
 *
 * The email class for channels - a test channel that just puts
 * notifications in a text file.
 */

require_once(_CLASSES_."mail.class.php");
include_once(_SUBSYSTEMS_."notif/channels/base.php");

/* {{{ Class Notif_Channel_Email */
class Notif_Channel_Email extends Notif_Channel_Base
{
  /* {{{ Constructor */
  /**
   * @param string $filename
   */
  function Notif_Channel_Email()
  {
    $this->notifications = array();
  }
  /* }}} */

  /* {{{ Function send_notifications */
  function send_notifications($userid, $changes, &$sent_addresses_by_issue_id)
  {
    $user = &get_user($userid);
    $email = $user->primary_email();
    if (!$email) { return; }

    // organize the changes by issueid
    $by_issueid = $this->sort_by_issueid($changes);


    foreach ($by_issueid as $issueid => $issue_changes) {
      $mailer = &new MAILER();

      if (!is_null($issueid)) {        
	$issue = &get_issue($issueid);
	// Get group name
	$groups = $issue->enumerate_groups_user($userid);
	unset ($groupname);
	foreach ($groups as $g) {
           $groupname = group_name($g);
	   break;
	}
	// Get notification Type
	$status = status_type_text($issue->status());

	$subject = "($groupname)($status) Issue #$issueid: ";

	$mailer->subject($subject . $issue->summary());
      } else {
        $mailer->subject("EnterTrack Notification");
      }

      $mailer->to($email);

      $mailer->message($this->format($issue_changes, "notif/plaintext.tpl"));
      $mailer->send();

      // Record for the caller's reference.
      $sent_addresses_by_issue_id[$issueid][] = $email;
    }
  }
  /* }}} */
}
/* }}} */

/* register the class */
$_ENV['notif']->register_channel(101, _("Email"), new Notif_Channel_Email());
