<?php

/*
 * sms.php
 *
 * Send notifications to users' pagers via SMS
 */

require_once(_CLASSES_."mail.class.php");
include_once(_SUBSYSTEMS_."notif/channels/base.php");

/* {{{ Class Notif_Channel_SMS */
class Notif_Channel_SMS extends Notif_Channel_Base
{
  /* {{{ Constructor */
  /**
   * @param string $filename
   */
  function Notif_Channel_Email()
  {
    $this->notifications = array();
  }
  /* }}} */

  /* {{{ Function send_notifications */
  function send_notifications($userid, $changes, &$sent_addresses_by_issue_id)
  {
    $user = &get_user($userid);
    $sms = $user->sms();
    if (!$sms) { return; }

    // organize the changes by issueid
    $by_issueid = $this->sort_by_issueid($changes);

    foreach ($by_issueid as $issueid => $issue_changes) {
      $mailer = &new MAILER();
      $mailer->set("email_from", $_ENV['config']['email']['sender']);

      if (!is_null($issueid)) {
        $issue = &get_issue($issueid);
        $mailer->subject("Issue #$issueid: " . $issue->summary());
      } else {
        $mailer->subject("EnterTrack Notification");
      }

      $mailer->to($sms);

      $mailer->message($this->format($issue_changes, "notif/sms.tpl"));
      $mailer->send();

      // Record for the caller's reference.
      $sent_addresses_by_issue_id[$issueid][] = $sms;
    }
  }
  /* }}} */
}
/* }}} */

/* register the class */
$_ENV['notif']->register_channel(102, _("SMS"), new Notif_Channel_SMS());
