<?php

/* {{{ Class Notif_Notice */
/**
 * A class representing a notice for a user; it has a change object,
 * a userid, and a list of reasons this user is being notified.
 */
class Notif_Notice
{
  /* {{{ Function constructor */
  /**
   * @param integer $userid the user to receive the notice
   * @param object $change the change object
   */
  function Notif_Notice($userid, &$change)
  {
    $this->userid = $userid;
    $this->change = &$change;
    $this->reasons = array();
  }
  /* }}} */

  /* {{{ Function add_reason */
  /**
   * Add a reason for this user to receive this notification
   *
   * @param string $reason the reason to add
   */
  function add_reason($reason)
  {
    $this->reasons[] = $reason;
  }
  /* }}} */
}
/* }}} */
