<?php
if (function_exists("gzopen")) {
  ob_start("ob_gzhandler");
}

header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");

define("BROWSER",TRUE);

require_once("./initialize.php");
initialize_entertrack('web');

// Disable templates if requested.  Useful for plaintext files, eg CSV.
if( !empty( $_GET['notpl'] ) || $_POST['format'] == 'csv' ) {
    $_ENV['tpl']->toggle_display( false );
}

if (isset($_GET['expired']) && $_GET['expired'] == "true") {
  session_destroy();
  $_ENV['tpl']->display("header.tpl");
  $_ENV['tpl']->display("expired.tpl");
  $_ENV['tpl']->display("footer.tpl");
  ob_flush();
  exit;
}

set_time_limit(_MINUTE_);

if (!empty($_SESSION['ip'])
and ($_SESSION['ip'] != $_SERVER['REMOTE_ADDR'])) {
  session_destroy();
  header("Location: "._URL_);
  exit;
}

if (isset($_GET['logout']) && $_GET['logout'] == "true") {
  session_destroy();
  if (isset($_GET['session_expired']) && $_GET['session_expired'] == "true") {
    header("Location: "._URL_."?session_expired=true");
  } else {
    header("Location: "._URL_);
    exit;
  }
}


if (isset($_GET['login']) && !empty($_POST['username']) and !empty($_POST['password'])) {
  authenticate($_POST['username'],$_POST['password']);
  if (!empty($_POST['redirect_url'])) {
    redirect($_POST['redirect_url']);
    exit;
  } else {
    redirect();
    exit;
  }
}

if (isset($_GET['module']) and $_GET['module'] == "download" and !empty($_GET['fid'])) {
  download($_GET['fid']);
}

if (isset($_SESSION['userid'])) {
  if (file_exists(_PATH_."/download/".$_SESSION['userid'])
  and $_GET['module'] != "download") {
    remove_dir(_PATH_."/download/".$_SESSION['userid']);
  }
}

if (empty($_GET['issueid'])) {
  if (!empty($_GET['tid'])) {
    $_GET['issueid'] = $_GET['tid'];
  }
  if (!empty($_POST['issueid'])) {
    $_GET['issueid'] = $_POST['issueid'];
  }
}

$user_has_admin = false;
if (isset($_SESSION['userid']))
{
  $user_has_admin = (is_employee($_SESSION['userid'])
	or permission_check("status_manager")
	or permission_check("category_manager")
	or permission_check("product_manager") );
}

$_ENV['tpl']->assign('user_admin_rights', $user_has_admin);
$_ENV['tpl']->display("header.tpl");

if (isset($_GET['debug'])) {
  $_SESSION['debugger'] = $_GET['debug'];
}

if ((isset($_GET['module']) and file_exists(_MODULES_.$_GET['module']."/noauth"))
or isset($_SESSION['userid'])) {
  if (isset($_GET['module']) and file_exists(_MODULES_.$_GET['module']."/noauth")) {
    $_GET['nonav'] = TRUE;
  }
  if (empty($_GET['nonav'])) {
    $leftnav_menu[_("Main")] = _URL_;

    // use specific includes here for the sake of a consistent ordering
    include("modules/announce/hooks/menus.php");
    include("modules/issues/hooks/menus.php");
    include("modules/prefs/hooks/menus.php");
    include("modules/reports/hooks/menus.php");
    include("modules/admin/hooks/menus.php");

    $leftnav_menu[_("Logout")] = "?logout=true";
    $pmenus = get_user_menu($_SESSION['userid']);

    $_ENV['tpl']->assign('leftnav_menu',$leftnav_menu);
    $_ENV['tpl']->assign('pmenus',$pmenus);
    $_ENV['tpl']->display("leftnav.tpl");

    $includes = module_includes("leftnav");
    foreach ($includes as $inc) {
      include($inc);
    }
  }


  if (isset($_GET['module']) and $_GET['module'] != "help" and !empty($_GET['module'])) {
    if (empty($_GET['action'])) {
      if (file_exists(_HELP_.$_GET['module'].".hlp")) {
        $_ENV['tpl']->assign('help_file',_HELP_.$_GET['module'].".hlp");
      }
    } else {
      if (file_exists(_HELP_.$_GET['module']."/".$_GET['action'].".hlp")) {
        $_ENV['tpl']->assign('help_file',_HELP_.$_GET['module']."/".$_GET['action'].".hlp");
      }
    }
  }


  if ($_GET['module'] != "help") {
    $module=$_GET['module'];
    $action=$_GET['action'];
    if ( ($action == "search_results") && ($_GET['print'] != "true") )  {

      echo '<form name="resubmit" method="post" action="?module=' . $module . '&action=' . $action. '&&print=true">';
      foreach ($_POST as $key => $value) {
        if ($key == "product" || $key == "groups" || $key == "opened" ||
            $key == "assigned" || $key == "status" || $key == "category") {
          $value = implode(",", $value);
        }
        echo '<input type="hidden" name="' . $key . '" value="' . $value . '" />';
      }
      echo '<input name="resub" type="submit" value="Printer Friendly Report" /></form>';
    } else {
      $_ENV['tpl']->display("iconbar.tpl");
    }
  }

  if (empty($_GET['module']) and $_SESSION['group_count'] <= 0) {
      $_ENV['error']->push_error(sprintf(_("Your user does not belong to any groups within this system.  Please contact %s to correct this."), $_ENV['config']['email']['admin']));
      $_ENV['tpl']->display("errors.tpl");
  } else {
    if (empty($_GET['module'])) {
	    $_GET['module'] = 'issues';
    }
    if ($_GET['module'] == "help") {
      if (empty($_GET['act'])) {
        $file = _HELP_.$_GET['mod'].".hlp";
      } else {
        $file = _HELP_.$_GET['mod']."/".$_GET['act'].".hlp";
      }
      
      if ($fp = fopen($file,"r")) {
        $buffer = fread($fp,filesize($file));
        fclose($fp);
      } else {
        $buffer = "Could not find a help file for requested module/action.";
      }
      $_ENV['tpl']->assign('help',$buffer);
      $_ENV['tpl']->display("help.tpl");
    } else {

      if (empty($_GET['action'])) {
        if (file_exists(_MODULES_.$_GET['module']."/".$_GET['module'].".php")) {
          include_once(_MODULES_.$_GET['module']."/".$_GET['module'].".php");
        }
      } else {
        if (file_exists(_MODULES_.$_GET['module']."/".$_GET['action'].".".$_GET['module'].".php")) {
	  include_once(_MODULES_.$_GET['module']."/".$_GET['action'].".".$_GET['module'].".php");
        }
      }
    }
  }

  if (empty($_GET['nonav'])) {
    $_ENV['tpl']->display("rightnav.tpl");
  }

} else {
  
  // adding code to store url info if provided...
  if (!empty($_SERVER['QUERY_STRING']))
    $target_url = $_SERVER['REQUEST_URI'];
  else
    $target_url = _URL_;

  $_ENV['tpl']->assign('target_url', $target_url);
  $_ENV['tpl']->assign('motd',get_motd());
  $_ENV['tpl']->assign('allow_register',$_ENV['config']['features']['auto_register']);

  if (!empty($_GET))
  {
    foreach( $_GET as $name=>$value ) {
      $get_vars[] = "{$name}={$value}";
    }
    $redirect_url = _URL_ . "?".implode("&amp;", $get_vars);
    $_ENV['tpl']->assign('redirect_url', $redirect_url);
  }

  $_ENV['tpl']->display("login.tpl");

}

$_ENV['tpl']->display("footer.tpl");

if (isset($_SESSION['debugger']) && $_SESSION['debugger'] == "on") {
  $_ENV['error']->debug($_SESSION,"Session Variables");
  $_ENV['error']->debug($_COOKIE,"Cookie Variables");
  $_ENV['error']->debug($_POST,"Post Variables");
  $_ENV['error']->debug($_GET,"GET Variables");
  $_ENV['error']->debug($_ENV,"Environment Variables");

  print "<script type=\"text/javascript\" language=\"javascript\">\n";
  print "debugwin.document.writeln('</table>');\n";
  print "debugwin.document.writeln('</body>');\n";
  print "debugwin.document.writeln('</html>');\n";
  print "</script>\n";
}

$_ENV['notif']->send_notifications();

ob_flush();

?>
