<?php
/***
 * Begin with some global initialization that needs to happen when this file is
 * loaded
 */

////
// PATH SETUP

// Make sure _PATH_ is defined, otherwise when we pull in the config
// file it will have no idea where to find our directories
if (!defined("_PATH_")) {
  define("_PATH_",dirname(__FILE__));
}

// Load all of the other predefined paths
include_once("conf/paths.php");

/* display errors during the module-loading process.  The error
 * subsystem will fix things up the way the user has configured
 * during late initialization.
 */
error_reporting(E_ALL);
ini_set("display_errors", TRUE);

// Load all of the other predefined paths
include_once("conf/paths.php");

////
// INCLUDES
// (order *is* important here)

/* general functions */
require_once(_INCLUDES_."functions/css.func.php");
require_once(_INCLUDES_."functions/file.func.php");
require_once(_INCLUDES_."functions/http.func.php");
require_once(_INCLUDES_."functions/menu.func.php");
require_once(_INCLUDES_."functions/module_api.func.php");
require_once(_INCLUDES_."functions/permissions.func.php");
require_once(_INCLUDES_."functions/sql.func.php");
require_once(_INCLUDES_."functions/time.func.php");

/* (specific includes/classes are included only as needed, for now) */

/* module classes */
require_once(_MODULES_."events/hooks/class.php");
require_once(_MODULES_."files/hooks/class.php");
require_once(_MODULES_."groups/hooks/class.php");
require_once(_MODULES_."issues/hooks/class.php");
require_once(_MODULES_."reports/hooks/class.php");
require_once(_MODULES_."users/hooks/class.php");

/* module functions */
require_once(_MODULES_."admin/hooks/funcs.php");
require_once(_MODULES_."announce/hooks/funcs.php");
require_once(_MODULES_."events/hooks/funcs.php");
require_once(_MODULES_."files/hooks/funcs.php");
require_once(_MODULES_."groups/hooks/funcs.php");
require_once(_MODULES_."issues/hooks/funcs.php");
require_once(_MODULES_."users/hooks/funcs.php");
require_once(_MODULES_."verify/hooks/funcs.php");

/* subsystems */
require_once(_SUBSYSTEMS_."init.php");

/* {{{ Function initialize_entertrack */

/**
 * Initialize all of EnterTrack for the indicated context, one of 'web',
 * 'email'.
 *
 * @param string $context the context for initialization
 */
function initialize_entertrack($context)
{
  // fire up the subsystems
  initialize_subsystems($context);

  // Load cache files
  if ($dir = opendir(_CACHE_)) {
    while (($file = readdir($dir)) !== false) {
      if (!$file or $file{0} == "." or $file == "CVS" or is_dir(_CACHE_.$file)) {
        continue;
      }
  
      if (is_file(_CACHE_.$file)) {
        include_once(_CACHE_.$file);
      }
    }
  
    closedir($dir);
  }
  
  if ($context == 'web') {
    if (isset($_SESSION['userid'])) {
      $_SESSION['groups'] = init_user_groups($_SESSION['userid']);
      $_SESSION['group_count'] = count($_SESSION['groups']);
      $_SESSION['prefs'] = user_preferences($_SESSION['userid']);
    }
  
    if (file_exists(_THEMES_.$_SESSION['theme']."/functions.php")) {
      include_once(_THEMES_.$_SESSION['theme']."/functions.php");
    }
  
    if (file_exists(_THEMES_.$_SESSION['theme']."/images.php")) {
      include_once(_THEMES_.$_SESSION['theme']."/images.php");
    }
  
    $title  = $_ENV['config']['display']['title'];
    $title .= !empty($_GET['module']) ? " :: "._(ucwords($_GET['module'])) : "";
    $title .= !empty($_GET['action']) ? " :: "._(ucwords(str_replace("_"," ",$_GET['action']))) : "";
    $title .= !empty($_GET['gid']) ? " :: "._("Group")." ".group_name($_GET['gid']) : "";
    $title .= !empty($_GET['issueid']) ? " :: ".$_GET['issueid'] : "";
    $_ENV['tpl']->assign('title',$title);
  }
}  
?>
