<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

// Build array for administration buttons
if (is_employee()) {
  $buttons = array(
    array(
      "img" => $_ENV['imgs']['user'],
      "txt" => _("User Management"),
      "url" => "?module=users",
      "sub" => array(
        _("New User") => "?module=users&action=new",
      )
    ),
    array(
      "img" => $_ENV['imgs']['group'],
      "txt" => _("Group Management"),
      "url" => "?module=groups",
      "sub" => array(
        _("New Group") => "?module=groups&action=new",
        _("Status Reports") => "?module=groups&action=status"
      )
    )
  );
}

if (is_manager($_SESSION['userid'])) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['motd'],
    "txt" => _("Message of the Day"),
    "url" => "?module=admin&action=edit_motd"
  );
}

if (is_admin($_SESSION['userid'])) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['debug'],
    "txt" => _("Debugging"),
    "sub" => array(
      _("Switch Users") => "?module=admin&action=switch_users",
      _("Toggle Debugger") => $_SESSION['debugger'] == "on" ? "?debug=off" : "?debug=on"
    )
  );

  $buttons[] = array(
    "img" => $_ENV['imgs']['permission'],
    "txt" => _("Permissions Management"),
    "url" => "?module=admin&action=permissions",
    "sub" => array(
      _("Create Permission") => "?module=admin&action=permissions&subaction=new",
      _("Permission Sets") => "?module=admin&action=permission_sets",
      _("New Permission Set") => "?module=admin&action=permission_sets&subaction=new"
    )
  );
}

if (permission_check("status_manager")) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['status'],
    "txt" => _("Status Management"),
    "url" => "?module=admin&action=statuses",
    "sub" => array(
      _("New Status") => "?module=admin&action=statuses&subaction=new"
    )
  );
}

if (permission_check("category_manager")) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['category'],
    "txt" => _("Category Management"),
    "url" => "?module=admin&action=categories",
    "sub" => array(
      _("New Category") => "?module=admin&action=categories&subaction=new"
    )
  );
}

if (permission_check("product_manager")) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['product'],
    "txt" => _("Product Management"),
    "url" => "?module=admin&action=products",
    "sub" => array(
      _("New Product") => "?module=admin&action=products&subaction=new"
    )
  );
}

if (permission_check("field_manager")) {
  $buttons[] = array(
    "img" => $_ENV['imgs']['field'],
    "txt" => _("Custom Field Management"),
    "url" => "?module=admin&action=fields",
    "sub" => array(
      _("New Custom Field Type") => "?module=admin&action=fields&subaction=new"
    )
  );
}

$_ENV['tpl']->assign('buttons',$buttons);
$_ENV['tpl']->display("admin/admin.tpl");
?>
