<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if(is_admin() or permission_check('category_manager')){
  if ($_GET['subaction'] == "delete"
  and !empty($_GET['id'])) {
    if ($_POST['confirm'] == "true") {
 	  	$result = $_ENV['dbi']->extended->autoExecute("categories",
        null,
        MDB2_AUTOQUERY_DELETE,
        "cid=" . $_ENV['dbi']->quote($_GET['id'], 'integer')); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      redirect("?module=admin&action=categories");
    } else {
      $_ENV['tpl']->display("admin/categories/delete.tpl");
    }
  } else if ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['category'])) {
        $_ENV['error']->push_error(_("Category can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT cid from categories where lower(category) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['category'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $cid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (!empty($cid)) {
          $_ENV['error']->push_error(_("That category already exists."));
        } else {
          $insert = array();
          $types = array();
          $insert['category'] = $_POST['category'];
          $types[] = 'text';

          $result = $_ENV['dbi']->extended->autoExecute("categories",
            $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=categories");
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("admin/categories/new.tpl");
    }
  } else if ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['category'])) {
        $_ENV['error']->push_error(_("Category can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT cid from categories where lower(category) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['category'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $cid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (empty($cid) or $cid == $_GET['id']) {
          $result = $_ENV['dbi']->extended->autoExecute("categories",
            array("category" => $_POST['category']),
            MDB2_AUTOQUERY_UPDATE,
            sprintf("cid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
            array('text')); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=categories");
        } else {
          $_ENV['error']->push_error(_("That category already exists."));
        }
      }
    } 

    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $category = category($_GET['id']);
      $_ENV['tpl']->assign('category',$category);
      $_ENV['tpl']->display("admin/categories/edit.tpl");
    }
  } else {
    $links[] = array(
      "txt" => _("Back to Administration"),
      "url" => "?module=admin",
      "img" => $_ENV['imgs']['back']
    );
    $links[] = array(
      "txt"	=> _("New Category"),
      "url" => "?module=admin&action=categories&subaction=new",
      "img" => $_ENV['imgs']['category']
    );

    $sql  = "SELECT cid,category ";
    $sql .= "FROM categories ";
    $sql .= "ORDER BY category";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $categories = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    $_ENV['tpl']->assign('categories',$categories);
    $_ENV['tpl']->display("admin/categories.tpl");
  }
} else {
  redirect();
}
?>
