<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if(is_admin() or permission_check('field_manager')){
  if ($_GET['subaction'] == "delete" and !empty($_GET['id'])) {
    if ($_POST['confirm'] == "true") {
        $result = $_ENV['dbi']->extended->autoExecute("custom_field_types",
          null,
          MDB2_AUTOQUERY_DELETE,
          "typeid=" . $_ENV['dbi']->quote($_GET['id'], 'integer')); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        redirect("?module=admin&action=fields");
    } else {
      $_ENV['tpl']->display("admin/fields/delete.tpl");
    }
  } else if ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['field_name'])) {
        $_ENV['error']->push_error(_("Field name cannot be empty."));
      } elseif (empty($_POST['field_type'])) {
      	$_ENV['error']->push_error(_("Field type must be defined"));
      } elseif (!is_uploaded_file($_FILES['field_tpl']['tmp_name'])) {
      	$_ENV['error']->push_error(_("Template file must be uploaded"));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT typeid FROM custom_field_types WHERE lower(name) = LOWER(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['field_name'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $typeid = $result->fetchOne(); 
        $result->free();
        $stmt->free();
        if (!empty($typeid)) {
          $_ENV['error']->push_error(_("That field type already exists."));
        } else {
          //Move uploaded tpl file into fields template directory.
          // 05/27/2005 - Dave Joyce: Removed _THEMES_ to allow relative paths
          // to custom field templates.
          $upload_dir  = 'default/tpl/fields/';
          $upload_file = $upload_dir . $_FILES['field_tpl']['name'];
          if (!move_uploaded_file($_FILES['field_tpl']['tmp_name'], $upload_file)) {
          	$_ENV['error']->push_error(_("Didn't upload template file"));
          } else {
            $insert = array();

	          $insert['type'] = $_POST['field_type'];
            $types[] = 'text';
	          $insert['tpl_path'] = $upload_file;
            $types[] = 'text';
	          $insert['name']	= $_POST['field_name'];
            $types[] = 'text';
  
	          $result = $_ENV['dbi']->extended->autoExecute("custom_field_types",
                $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
            $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          }
	        redirect("?module=admin&action=fields");
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("admin/fields/new.tpl");
    }
  } else if ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['field_type'])) {
        $_ENV['error']->push_error(_("Field type can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT typeid FROM custom_field_types WHERE lower(name) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['field_name'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $typeid = $result->fetchOne(); 
        $result->free();
        $stmt->free();
        if (empty($typeid) or $typeid == $_GET['id']) {
          $result = $_ENV['dbi']->extended->autoExecute("custom_field_types",
            array("type" => $_POST['field_type']),
            MDB2_AUTOQUERY_UPDATE,
            sprintf("typeid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
            array('text')); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=fields");
        } else {
          $_ENV['error']->push_error(_("That fieldtype already exists."));
        }
      }
    } 

    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $sql  = "SELECT name,type,tpl_path ";
      $sql .= "FROM custom_field_types ";
      $sql .= "WHERE typeid=? ";
      $stmt = $_ENV['dbi']->prepare($sql);
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($_GET['id']));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $fields = $result->fetchRow(MDB2_FETCHMODE_ORDERED); 
      $result->free();
      $stmt->free();
      $_ENV['tpl']->assign('field_name',$fields[0]);
      $_ENV['tpl']->assign('field_type',$fields[1]);
      $_ENV['tpl']->assign('field_tpl',$fields[2]);
      $_ENV['tpl']->display("admin/fields/edit.tpl");
    }
  } else {
    $links[] = array(
      "txt" => _("Back to Administration"),
      "url" => "?module=admin",
      "img" => $_ENV['imgs']['back']
    );
    $links[] = array(
      "txt" => _("New Custom Field Type"),
      "url" => "?module=admin&action=fields&subaction=new",
      "img" => $_ENV['imgs']['field']
    );

    $sql  = "SELECT typeid,name,type,tpl_path ";
    $sql .= "FROM custom_field_types ";
    $sql .= "ORDER BY type";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $fields = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    $_ENV['tpl']->assign('fields',$fields);
    $_ENV['tpl']->display("admin/fields.tpl");
  }
} else {
  redirect();
}
?>
