<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

/* {{{ Function: colorize_log */
/**
 * Colorize log output for easy viewing
 *
 * @param string $buffer Information to colorize
 */
function colorize_log($buffer)
{
  $buffer = str_replace("[","<font color=\"red\">[</font>",$buffer);
  $buffer = str_replace("]","<font color=\"red\">]</font>",$buffer);
  $buffer = str_replace("(","<font color=\"red\">(</font>",$buffer);
  $buffer = str_replace(")","<font color=\"red\">)</font>",$buffer);
  $buffer = str_replace("{","<font color=\"red\">{</font>",$buffer);
  $buffer = str_replace("}","<font color=\"red\">}</font>",$buffer);
  $buffer = str_replace("Array","<font color=\"blue\">Array</font>",$buffer);
  $buffer = str_replace("=>","<font color=\"magenta\">=></font>",$buffer);
  $buffer = str_replace(":","<font color=\"green\">:</font>",$buffer);
  return $buffer;
}
/* }}} */

/* {{{ Function: get_motd */
/**
 * Get the MOTD as a string
 *
 * @return string the motd
 */
function get_motd()
{
  $stmt = $_ENV['dbi']->prepare("select motd from motd limit 1");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute();
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $motd = $result->fetchOne();
  $result->free();
  $stmt->free();

  return $motd;
}
/* }}} */

/* {{{ Function: set_motd */
/**
 * Get the MOTD as a string
 *
 * @param string $motd the motd
 */
function set_motd($motd)
{
  $result = $_ENV['dbi']->extended->autoExecute("motd", null, MDB2_AUTOQUERY_DELETE); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

  $result = $_ENV['dbi']->extended->autoExecute("motd",
    array("motd" => $motd),
    MDB2_AUTOQUERY_INSERT,
    null,
    array('text')); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
}
/* }}} */

?>
