<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (!is_admin($_SESSION['userid'])) {
  $_ENV['error']->push_error(_("You do not have permission to edit permissions."));
  redirect();
}

$stmt = $_ENV['dbi']->prepare("SELECT permission FROM permissions WHERE group_perm != 't' AND user_perm != 't'");
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute();
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$perms = $result->fetchCol(); 
$result->free();
$stmt->free();
$_ENV['tpl']->assign('perms',$perms);

if ($_GET['subaction'] == "delete") {
  $stmt = $_ENV['dbi']->prepare("SELECT system from permission_sets where permsetid=?");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['id']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $system = $result->fetchOne(); 
  $result->free();
  $stmt->free();

  if ($system == "t") {
    $_ENV['error']->push_error(_("This is a system permission set, it can not be deleted."));
    redirect("?module=admin&action=permission_sets");
  }
    
	if ($_POST['confirm'] == "true") {
		$result = $_ENV['dbi']->extended->autoExecute("permission_sets",
           null,
           MDB2_AUTOQUERY_DELETE,
           "permsetid=" . $_ENV['dbi']->quote($_GET['setid'], 'integer')); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    redirect("?module=admin&action=permission_sets");
	} else {
    $_ENV['tpl']->display("admin/permission_sets/delete.tpl");
	}
} else if ($_GET['subaction'] == "edit") {
	if ($_POST['update'] == "true") {
    if (!is_array($_POST['permissions'])) {
      $_ENV['error']->push_error(_("Permission sets must contain at least 1 permission."));
    } else {
      $stmt = $_ENV['dbi']->prepare("SELECT permsetid from permission_sets where lower(name) = lower(?)");
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array(trim($_POST['name'])));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $psetid = $result->fetchOne(); 
      $result->free();
      $stmt->free();

      if (empty($psetid) or $psetid == $_GET['setid']) {
        $update = array();
        $types = array();
        $update['name'] = $_POST['name'];
        $types[] = 'text';
        $update['description'] = $_POST['description'];
        $types[] = 'text';
        $update['permissions'] = implode(",",$_POST['permissions']);
        $types[] = 'text';

        $result = $_ENV['dbi']->extended->autoExecute("permission_sets",
          $update,
          MDB2_AUTOQUERY_UPDATE,
          sprintf("permsetid=%s", $_ENV['dbi']->quote($_GET['setid'], 'integer')),
          $types); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        redirect("?module=admin&action=permission_sets");
      } else {
        $_ENV['error']->push_error(_("A permission set with that name already exists."));
      }
    }
	}

	$sql  = "SELECT name,description,permissions ";
	$sql .= "FROM permission_sets ";
	$sql .= "WHERE permsetid = ?";
  $stmt = $_ENV['dbi']->prepare($sql);
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['setid']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $pset = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
  $result->free();
  $stmt->free();
  $pset['name'] = $pset['name'];
  $pset['description'] = $pset['description'];
  $pset['permissions'] = explode(",",$pset['permissions']);
  $_ENV['tpl']->assign('pset',$pset);
  $_ENV['tpl']->display("admin/permission_sets/edit.tpl");
}	else if ($_GET['subaction'] == "new") {
	if (!empty($_POST['name'])) {
    if (!is_array($_POST['permissions'])) {
      $_ENV['error']->push_error(_("Permission sets must include at least 1 permission."));
    } else {
      $stmt = $_ENV['dbi']->prepare("SELECT permsetid from permission_sets where lower(name) = lower(?)");
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array(trim($_POST['nome'])));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $psetid = $result->fetchOne(); 
      $result->free();
      $stmt->free();

      if (!empty($psetid)) {
        $_ENV['error']->push_error(_("A permission set with that name already exists."));
      } else {
        $insert = array();
        $types = array();
        $insert['name'] = $_POST['name'];
        $types[] = 'text';
        $insert['description'] = $_POST['description'];
        $types[] = 'text';
        $insert['permissions'] = implode(",",$_POST['permissions']);
        $types[] = 'text';
        $result = $_ENV['dbi']->extended->autoExecute("permission_sets",
          $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        redirect("?module=admin&action=permission_sets");
      }
    }
	}

  $_ENV['tpl']->display("admin/permission_sets/new.tpl");
} else {
  $links[] = array(
    "txt" => _("Back to Administration"),
    "url" => "?module=admin",
    "img" => $_ENV['imgs']['back']
  );
  $links[] = array(
    "txt" => _("New Permission Set"),
    "url" => "?module=admin&action=permission_sets&subaction=new",
    "img" => $_ENV['imgs']['permission']
  );

  $sql  = "SELECT * ";
  $sql .= "FROM permission_sets ";
  $stmt = $_ENV['dbi']->prepare($sql);
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute();
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $psets = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
  $result->free();
  $stmt->free();
  $num_sets = count($psets);
  for ($x = 0;$x < $num_sets;$x++) {
    $psets[$x]['name'] = $psets[$x]['name'];
    $psets[$x]['description'] = $psets[$x]['description'];
    $psets[$x]['permissions'] = explode(",",$psets[$x]['permissions']);
  }
  $_ENV['tpl']->assign('rowspan',count($perms));
  $_ENV['tpl']->assign('psets',$psets);
  $_ENV['tpl']->display("admin/permission_sets.tpl");
}
?>
