<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if(is_admin()){
  if ($_GET['subaction'] == "delete"
  and !empty($_GET['id'])) {
    $stmt = $_ENV['dbi']->prepare("SELECT system from permissions where permid=?");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($_GET['id']));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $system = $result->fetchOne(); 
    $result->free();
    $stmt->free();
    if ($system == "t") {
      $_ENV['error']->push_error(_("This is a system permission, it can not be deleted."));
      redirect("?module=admin&action=permissions");
    }
    
    if ($_POST['confirm'] == "true") {
 	  	$result = $_ENV['dbi']->extended->autoExecute("permissions",
          null,
          MDB2_AUTOQUERY_DELETE,
          "permid=" . $_ENV['dbi']->quote($_GET['id'], 'integer')); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      redirect("?module=admin&action=permissions");
    } else {
      $_ENV['tpl']->display("admin/permissions/delete.tpl");
    }
  } else if ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['permission'])) {
        $_ENV['error']->push_error(_("Permission can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT permid from permissions where lower(permission) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['permission'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $permid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (!empty($permid)) {
          $_ENV['error']->push_error(_("That permission already exists."));
        } else {
          $types = array();
          $insert = array();
          $insert['permission'] = $_POST['permission'];
          $types[] = 'text';
          $insert['group_perm'] = $_POST['group'] == "on" ? "t" : "f";
          $types[] = 'text';
          $insert['user_perm'] = $_POST['user'] == "on" ? "t" : "f";
          $types[] = 'text';
          $result = $_ENV['dbi']->extended->autoExecute("permissions",
            $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          unset($insert);
          redirect("?module=admin&action=permissions");
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("admin/permissions/new.tpl");
    }
  } else if ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    $stmt = $_ENV['dbi']->prepare("SELECT system from permissions where permid=?");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($_GET['id']));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $system = $result->fetchOne(); 
    $result->free();
    $stmt->free();

    if ($system == "t") {
      $_ENV['error']->push_error(_("This is a system permission, it can not be editted."));
      redirect("?module=admin&action=permissions");
    }
    
    if ($_POST['commit'] == "true") {
      if (empty($_POST['permission'])) {
        $_ENV['error']->push_error(_("Permission can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT permid from permissions where lower(permission) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['permission'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
        $permid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (empty($permid) or $permid == $_GET['id']) {
          $update = array();
          $types = array();
          $update['permission'] = $_POST['permission'];
          $types[] = 'text';
          $update['group_perm'] = $_POST['group'] == "on" ? "t" : "f";
          $types[] = 'text';
          $update['user_perm'] = $_POST['user'] == "on" ? "t" : "f";
          $types[] = 'text';
          $result = $_ENV['dbi']->extended->autoExecute("permissions",
            $update,
            MDB2_AUTOQUERY_UPDATE,
            sprintf("permid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
            $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

          redirect("?module=admin&action=permissions");
        } else {
          $_ENV['error']->push_error(_("That permission already exists."));
        }
      }
    } 

    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $sql  = "SELECT permission,user_perm,group_perm ";
      $sql .= "FROM permissions ";
      $sql .= "WHERE permid=?";
      $stmt = $_ENV['dbi']->prepare($sql);
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($_GET['id']));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $permission = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
      $result->free();
      $stmt->free();
      $_ENV['tpl']->assign('permission',$permission);
      $_ENV['tpl']->display("admin/permissions/edit.tpl");
    }
  } else {
    $links[] = array(
      "txt" => _("Back to Administration"),
      "url" => "?module=admin",
      "img" => $_ENV['imgs']['back']
    );
    $links[] = array(
      "txt"	=> _("New Permission"),
      "url"	=> "?module=admin&action=permissions&subaction=new",
      "img" => $_ENV['imgs']['permission']
    );
    $links[] = array(
      "txt" => _("Permission Sets"),
      "url" => "?module=admin&action=permission_sets",
      "img" => $_ENV['imgs']['permission']
    );

    $sql  = "SELECT permid,permission,group_perm,user_perm,system ";
    $sql .= "FROM permissions ";
    $sql .= "ORDER BY permission";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $permissions = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    $_ENV['tpl']->assign('permissions',$permissions);
    $_ENV['tpl']->display("admin/permissions.tpl");
  }
} else {
  redirect();
}
?>
