<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if(is_admin() or permission_check('product_manager')){
  if ($_GET['subaction'] == "delete"
  and !empty($_GET['id'])) {
    if ($_POST['confirm'] == "true") {
 	  	$result = $_ENV['dbi']->extended->autoExecute("products",
          null,
          MDB2_AUTOQUERY_DELETE,
          "pid=" . $_ENV['dbi']->quote($_GET['id'], 'integer')); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      redirect("?module=admin&action=products");
    } else {
      $_ENV['tpl']->display("admin/products/delete.tpl");
    }
  } else if ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['product'])) {
        $_ENV['error']->push_error(_("Product can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT pid from products where lower(product) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['product'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
        $pid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (!empty($pid)) {
          $_ENV['error']->push_error(_("This product already exists."));
        } else {
          $insert = array('product' => $_POST['product']);
          $types = array('text');
          $result = $_ENV['dbi']->extended->autoExecute("products",
            $insert,
            MDB2_AUTOQUERY_INSERT,
            null,
            $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=products");
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("admin/products/new.tpl");
    }
  } else if ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    if (!empty($_POST['commit'])) {
      if (empty($_POST['product'])) {
        $_ENV['error']->push_error(_("Product can not be empty."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT pid from products where lower(product) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['product'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $pid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (empty($pid) or $pid == $_GET['id']) {
          $result = $_ENV['dbi']->extended->autoExecute("products",
            array("product" => $_POST['product']),
            MDB2_AUTOQUERY_UPDATE,
            sprintf("pid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
            array('text')); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          #redirect("?module=admin&action=products");
        } else {
          $_ENV['error']->push_error(_("That product already exists."));
        }
      }
    } 
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      	$product = product($_GET['id']);
      	// Added by David Trejos - Gridshield (david@gridshield.net)
      	// Add bgcolor by hours opened
	if (!empty($_POST['addLevel']) || !empty($_POST['level']) || !empty($_POST['color'])){
	   $sql = "SELECT true from products_levels where pid = ? and level = ? order by level";
	   $stmt = $_ENV['dbi']->prepare($sql);
	   $result = $stmt->execute(array($_GET['id'],$_POST['level']));
	   $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	   $addlevel = $result->fetchOne();
	   $result->free();
	   $stmt->free();
           if ($addlevel != true) {
	       $insert = array('pid'=>$_GET['id'], 'level'=>trim($_POST['level']),
	                       'color'=>trim($_POST['color']));
	       $result = $_ENV['dbi']->extended->autoExecute("products_levels",
	                    $insert,
	                    MDB2_AUTOQUERY_INSERT,
	                    null,
	                    $types);
	       $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	    }
	}
	
        if (!empty($_GET['level']) || !empty($_GET['deleteLevel'])){
	    $result = $_ENV['dbi']->extended->autoExecute("products_levels",
			         null,
	 	                 MDB2_AUTOQUERY_DELETE,
			         "pid=" . $_ENV['dbi']->quote($_GET['id'], 'integer').
			         " and level =". $_ENV['dbi']->quote($_GET['level'], 'integer'));
			         $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	}

	$sql  = "select level, color ";
	$sql .= "from products_levels where pid = ? order by level";
	$stmt = $_ENV['dbi']->prepare($sql);
	$result = $stmt->execute(array($_GET['id']));
	$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	$levels = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
	$result->free();
	$stmt->free();
	// --
	$_ENV['tpl']->assign('levels',$levels);
      	$_ENV['tpl']->assign('product',$product);
      	$_ENV['tpl']->display("admin/products/edit.tpl");
    }
  } else {
    $links[] = array(
      "txt" => _("Back to Administration"),
      "url" => "?module=admin",
      "img" => $_ENV['imgs']['back']
    );
    $links[] = array(
      "txt" => _("New Product"),
      "url" => "?module=admin&action=products&subaction=new",
      "img" => $_ENV['imgs']['product']
    );

    $sql  = "SELECT pid,product ";
    $sql .= "FROM products ";
    $sql .= "ORDER BY product";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $products = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    $_ENV['tpl']->assign('products',$products);
    $_ENV['tpl']->display("admin/products.tpl");
  }
} else {
  redirect();
}
?>
