<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

// Used to make sure only 1 "Registered" status is defined
$registered = fetch_status(TYPE_REGISTERED);
$_ENV['tpl']->assign('status_types',$status_types);

if(is_admin() or permission_check('status_manager')){
  if ($_GET['subaction'] == "delete"
  and !empty($_GET['id'])) {
    if ($_POST['confirm'] == "true") {
 	  	$result = $_ENV['dbi']->extended->autoExecute("statuses",
          null,
          MDB2_AUTOQUERY_DELETE,
          "sid=" . $_ENV['dbi']->quote($_GET['id'], "integer")); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      redirect("?module=admin&action=statuses");
    } else {
      $_ENV['tpl']->display("admin/statuses/delete.tpl");
    }
  } else if ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['status'])) {
        $_ENV['error']->push_error(_("Status can not be empty."));
      } else if ($_POST['status_type'] == TYPE_REGISTERED
      and count($registered) > 0) {
        $_ENV['error']->push_error(_("Only one \"Registered\" status is allowed."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT sid from statuses where lower(status) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['status'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $sid = $result->fetchOne(); 
        $result->free();
        $stmt->free();
        if (!empty($sid)) {
          $_ENV['error']->push_error(_("This status already exists."));
        } else {
          $insert = array();
          $types = array();
          $insert['status'] = $_POST['status'];
          $types[] = 'text';
          $insert['status_type'] = $_POST['status_type'];
          $types[] = 'integer';
          $result = $_ENV['dbi']->extended->autoExecute("statuses",
            $insert,
            MDB2_AUTOQUERY_INSERT,
            null,
            $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=statuses");
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("admin/statuses/new.tpl");
    }
  } else if ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['status'])) {
        $_ENV['error']->push_error(_("Status can not be empty."));
      } else if ($_POST['status_type'] == TYPE_REGISTERED
      and count($registered) > 0) {
        $_ENV['error']->push_error(_("Only one \"Registered\" status is allowed."));
      } else {
        $stmt = $_ENV['dbi']->prepare("SELECT sid from statuses where lower(status) = lower(?)");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array(trim($_POST['status'])));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $sid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (empty($sid) or $sid == $_GET['id']) {
          $update = array();
          $types = array();
          $update['status'] = $_POST['status'];
          $types[] = 'text';
          $update['status_type'] = $_POST['status_type'];
          $types[] = 'integer';
          $result = $_ENV['dbi']->extended->autoExecute("statuses",
            $update,
            MDB2_AUTOQUERY_UPDATE,
            sprintf("sid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
            $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          redirect("?module=admin&action=statuses");
        } else {
          $_ENV['error']->push_error(_("This status already exists."));
        }
      }
    } 

    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $sql  = "SELECT status,status_type ";
      $sql .= "FROM statuses ";
      $sql .= "WHERE sid=?";
      $stmt = $_ENV['dbi']->prepare($sql);
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($_GET['id']));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $status = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
      $result->free();
      $stmt->free();
      $_ENV['tpl']->assign('status',$status);
      $_ENV['tpl']->display("admin/statuses/edit.tpl");
    }
  } else {
    $links[] = array(
      "txt" => _("Back to Administration"),
      "url" => "?module=admin",
      "img" => $_ENV['imgs']['back']
    );
    $links[] = array(
      "txt" => _("New Status"),
      "url" => "?module=admin&action=statuses&subaction=new",
      "img" => $_ENV['imgs']['status']
    );

    $sql  = "SELECT sid,status,status_type ";
    $sql .= "FROM statuses ";
    $sql .= "ORDER BY status";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);  
    $statuses = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    $num_statuses = count($statuses);
    for ($x = 0;$x < $num_statuses;$x++) {
      $idx = $statuses[$x]['status_type'];
      $statuses[$x]['status_type'] = $status_types[$idx];
    }
    $_ENV['tpl']->assign('statuses',$statuses);
    $_ENV['tpl']->display("admin/statuses.tpl");
  }
} else {
  redirect();
}
?>
