<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

////
// Object access

/* {{{ Function: get_file */
/**
 * Get the file object for the given fid.
 *
 * @param integer $fid
 * @return object the File object
 */
function get_file($fid)
{
  static $file_cache = array();

  if (!array_key_exists($fid, $file_cache)) {
    $sql  = "SELECT fid, userid, typeid, uploaded_on, name, file_type, private ";
    $sql .= "FROM files ";
    $sql .= "WHERE fid=? ";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($fid));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
    $file_row = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();

    $file_cache[$fid] =& new File($fid, $file_row);
  }

  return $file_cache[$fid];
}
/* }}} */

/* {{{ Function: add_new_file */
/**
 * Add a new file to the system
 *
 * @param integer $userid the userid responsible for the addition (null for anonymous)
 * @param integer $typeid the id of some other object that "owns" this file (see $file_type)
 * @param string $name the filename
 * @param string $file_type the type of object that owns this file (e.g., "issue")
 * @param boolean $private is this file private?
 * @return object the File object, or FALSE if an error occurred
 */
function add_new_file($userid, $typeid, $name, $file_type, $private)
{
  // TODO add more functionality for actually storing the file data
  // Get the 'Registered' status
  list($registered) = fetch_status(TYPE_REGISTERED);

  $insert = array();
  $types = array();
  $insert['userid'] = $userid;
  $types[] = 'integer';
  $insert['typeid'] = $typeid;
  $types[] = 'integer';
  $insert['uploaded_on'] = time();
  $types[] = 'integer';
  $insert['name'] = $name;
  $types[] = 'text';
  $insert['file_type'] = $file_type;
  $types[] = 'text';
  $insert['private'] = $private?'t':'f';
  $types[] = 'text';
  $result = $_ENV['dbi']->extended->autoExecute("files",
    $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
  $fid = dbi_last_insert_id_fix("files", "fid");

  if (empty($fid)) {
    logger("Could not add new file object '$name'", "phperrors");
    return false;
  }

  return get_file($fid);
}
/* }}} */
