<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
    exit;
}

if (!is_employee() or empty($_GET['type'])) {
  $_ENV['error']->push_error("You do not have permission to edit" . htmlentities($_GET['type']));
  redirect();
}

$wizard = array("categories","products","statuses");

/* {{{ Edit Types */
$edit_types = array(
    /* {{{ Categories */
    "categories" => array(
        "gtable"    => "group_categories",
        "table"        => "categories",
        "id"            => "cid",
        "field"        => "category",
        "gfunc"        => "group_categories",
        "func"        => "category",
        "single"    => _("category"),
        "plural"    => _("categories")
    ),
    /* }}} */
    /* {{{ Products */
    "products" => array(
        "gtable"    => "group_products",
        "table"        => "products",
        "id"            => "pid",
        "field"        => "product",
        "gfunc"        => "group_products",
        "func"        => "product",
        "single"    => _("product"),
        "plural"    => _("products")
    ),
    /* }}} */
    /* {{{ Statuses */
    "statuses" => array(
        "gtable"    => "group_statuses",
        "table"        => "statuses",
        "id"            => "sid",
        "field"        => "status",
        "gfunc"        => "group_statuses",
        "func"        => "status",
        "single"    => _("status"),
        "plural"    => _("statuses")
    ),
    /* }}} */
    /* {{{ Internal Statuses */
    "istatuses" => array(
        "gtable"    => "group_istatuses",
        "table"        => "statuses",
        "id"            => "sid",
        "field"        => "status",
        "gfunc"        => "group_istatuses",
        "func"        => "status",
        "single"    => _("internal status"),
        "plural"    => _("internal statuses")
    ),
    /* }}} */
    /* {{{ Escalation Points */
    "escalation" => array(
        "gtable"    => "escalation_points",
        "table"        => "groups",
        "id"            => "gid",
        "field"        => "name",
        "gfunc"        => "escalation_groups",
        "func"        => "group_name",
        "single"    => _("escalation point"),
        "plural"    => _("escalation points")
    )
    /* }}} */
);
/* }}} */

/* {{{ Short Form Variables */
$id         = $edit_types[$_GET['type']]['id'];
$field    = $edit_types[$_GET['type']]['field'];
$gtable    = $edit_types[$_GET['type']]['gtable'];
$table    = $edit_types[$_GET['type']]['table'];
$gfunc    = $edit_types[$_GET['type']]['gfunc'];
$func        = $edit_types[$_GET['type']]['func'];
$single    = $edit_types[$_GET['type']]['single'];
$plural    = $edit_types[$_GET['type']]['plural'];
/* }}} */

if ($_GET['submit'] == "true") {
    if (is_array($_POST['add'])) {
        foreach ($_POST['add'] as $val) {
            $insert = array();
            $types = array();

            $insert['gid']    = $_GET['gid'];
            $types[] = 'integer';
            if ($_GET['type'] == "escalation") {
                $insert['egid'] = $val;
                $types[] = 'integer';
            } else {
                $insert[$id] = $val;
                $types[] = 'integer';
            }

            $result = $_ENV['dbi']->extended->autoExecute($gtable,
              $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
            $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        }
    }

    if (is_array($_POST['del'])) {
    foreach ($_POST['del'] as $val) {
      $result = $_ENV['dbi']->extended->autoExecute($gtable,
        null,
        MDB2_AUTOQUERY_DELETE,
        "gid=" . $_ENV['dbi']->quote($_GET['gid'], "integer") . " AND " .
                ($_GET['type'] == 'escalation'?'egid':$id) . '=' .
                $_ENV['dbi']->quote($val)); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    }
    }

  if (isset($_SESSION['GROUP_WIZARD'])) {
    if (in_array($_GET['type'],$wizard)) {
      $sql  = "SELECT count($id) "; // safe (see short form variables, above)
      $sql .= "FROM $gtable "; // safe (see short form variables, above)
      $sql .= "WHERE gid=? ";
      $stmt = $_ENV['dbi']->prepare($sql); 
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($_GET['gid']));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $num = $result->fetchOne();
      $result->free();
      $stmt->free();

      if ($num < 1) {
        // $single and $plural are already translated, above
        $_ENV['error']->push_error(sprintf(_("Groups must have at least one %s."), $single));
        $_ENV['error']->push_error(sprintf(_("If no %s are available to add to this group, contact the system admin at %s."), $plural, $_ENV['config']['email']['admin']));
      } else {
        if (array_search($_GET['type'],$wizard) == (count($wizard) - 1)) {
          unset($_SESSION['GROUP_WIZARD']);
          redirect("?module=groups&action=view&gid=".$_GET['gid']);
        } else {
          $type = $wizard[array_search($_GET['type'],$wizard) + 1];
          redirect("?module=groups&action=edit&type=$type&gid=".$_GET['gid']);
        }
      }
    } else {
      redirect("?module=groups&action=edit&type=".$_GET['type']."&gid=".$_GET['gid']);
    }
  } else {
    redirect("?module=groups&action=view&gid=".$_GET['gid']);
  }
}

if (group_exists($_GET['gid'])) {
  $links[] = array(
    "txt" => _("Back to Group Information"),
    "url" => "?module=groups&action=view&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['back']
  );

  $_ENV['tpl']->assign('plural',$plural);
  $_ENV['tpl']->assign('title',group_name($_GET['gid'])." "._(ucwords($plural)));
  
  $list = $gfunc($_GET['gid']);
  $_ENV['tpl']->assign('list',$list);

  $sql  = "SELECT $id as id,$field as field "; // safe (see short form variables, above)
  $sql .= "FROM $table ";
  $sql .= "ORDER BY $field";
  $stmt = $_ENV['dbi']->prepare($sql);
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute();
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $data = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
  $result->free();
  $stmt->free();

  $_ENV['tpl']->assign('data',$data);

  $_ENV['tpl']->display("groups/edit.tpl");
} else {
  redirect("?module=groups");
}
?>
