<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['gid'])) {
  redirect("?module=groups");
}

if (!is_employee() && !permission_check("update_group",$_GET['gid'])) {
  $_ENV['error']->push_error(_("You do not have permission to update this group."));
  redirect("?module=groups");
}

$links[] = array(
  "txt" => _("Back to Group Information"),
  "url" => "?module=groups&action=view&gid=".$_GET['gid'],
  "img" => $_ENV['imgs']['back']
);

if (isset($_POST['add_groups']) and is_array($_POST['add_groups']) and @count($_POST['add_groups']) > 0) {
  foreach ($_POST['add_groups'] as $child) {
    group_assign_add($_GET['gid'],$child);
  }
}

if (isset($_POST['del_groups']) and is_array($_POST['del_groups']) and @count($_POST['del_groups']) > 0) {
  foreach ($_POST['del_groups'] as $child) {
    group_assign_del($_GET['gid'],$child);
  }
}

$sql  = "SELECT a.assignee_gid AS gid,g.name AS name ";
$sql .= "FROM assign_groups AS a ";
$sql .= "JOIN groups AS g ON g.gid=a.assignee_gid ";
$sql .= "WHERE a.assignor_gid=? ";
$sql .= "ORDER BY g.name ";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$res = $stmt->execute(array($_GET['gid']));
$results = $res->fetchAll(MDB2_FETCHMODE_ASSOC); 
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$res->free();
$stmt->free();

$assignees = array();
if ($results) {
  foreach ($results as $assignee_row) {
    $assignees[$assignee_row['gid']] = $assignee_row['name'];
  }
}

$_ENV['tpl']->assign('assignees',$assignees);
$_ENV['tpl']->assign('possible',possible_viewer_groups($_GET['gid']));
$_ENV['tpl']->display("groups/assign_groups/view.tpl");
?>
