<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

// require employee status to change this stuff
if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to edit group fields."));
  redirect();
}

if (empty($_GET['gid'])) {
	redirect();
}

if(is_employee() or permission_check('field_manager')){
  if ($_GET['subaction'] == "delete" and !empty($_GET['id'])) {
    if ($_POST['confirm'] == "true") {
      $result = $_ENV['dbi']->extended->autoExecute("group_field_values",
        null,
        MDB2_AUTOQUERY_DELETE,
        "gfid=" . $_ENV['dbi']->quote($_GET['id'], "integer")); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      
 	  $result = $_ENV['dbi']->extended->autoExecute("group_fields",
        null,
        MDB2_AUTOQUERY_DELETE,
        "gfid=" . $_ENV['dbi']->quote($_GET['id'], "integer")); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

      redirect("?module=groups&action=edit_group_fields&gid=".$_GET['gid']);
    } else {
      $_ENV['tpl']->display("groups/group_fields/delete.tpl");
    }
  } elseif ($_GET['subaction'] == "new") {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['field_name'])) {
        $_ENV['error']->push_error(_("Field Name cannot be empty."));
      } else
      if (empty($_POST['field_type'])) {
        $_ENV['error']->push_error(_("Field Type must be selected."));
      } else {
      	$name = strtolower(str_replace(" ", "_", $_POST['field_name']));
        $stmt = $_ENV['dbi']->prepare("SELECT gfid from group_fields where lower(name) = lower(?) and gid=?");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array($name, $_GET['gid']));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        $gfid = $result->fetchOne(); 
        $result->free();
        $stmt->free();

        if (!empty($gfid)) {
          $_ENV['error']->push_error(_("This field already exists."));
        } else {
          $insert = array();
          $types = array();
          $insert['gid']    = $_GET['gid'];
          $types[] = 'integer';
          $insert['typeid'] = $_POST['field_type'];
          $types[] = 'integer';
          $insert['name']   = $name;
          $types[] = 'text';
          $insert['label']  = ucwords(str_replace("_", " ", $name));
          $types[] = 'text';
          $result = $_ENV['dbi']->extended->autoExecute("group_fields",
            $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          $gfid = dbi_last_insert_id_fix("group_fields", "gfid");
          
          //Display value form if field type is checkbox or select*.
          $stmt = $_ENV['dbi']->prepare("SELECT type from custom_field_types where typeid=?");
          $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
          $result = $stmt->execute(array($_POST['field_type']));
          $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
          $type = $result->fetchOne(); 
          $result->free();
          $stmt->free();
          if (preg_match("/^(checkbox|select)/", $type)) {
          	$_ENV['tpl']->assign("gfid", $gfid);
          	$_ENV['tpl']->assign("name", $_POST['field_name']);
          	$_ENV['tpl']->assign("type", $type);
          	$_ENV['tpl']->display("groups/group_fields/values.tpl");
          } else {
          	redirect("?module=groups&action=edit_group_fields&gid=".$_GET['gid']);
          }
        }
      }
    }
    
    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $_ENV['tpl']->display("groups/group_fields/view.tpl");
    }
  } elseif ($_GET['subaction'] == "values" and !empty($_POST['gfid'])) {
  	if ($_POST['commit'] == "true") {
  	  $type   = $_POST['type'];
  	  $values = array();
  	  if ($type == "checkbox") {
        $insert = array();
        $types = array();
  	  	$insert['gfid'] = $_POST['gfid'];
        $types = 'integer';
  	  	$insert['value_idx'] = 1;
        $types = 'integer';
  	  	$insert['value'] = $_POST['field_value'];
        $types = 'text';
  	  	$insert['is_default'] = ($_POST['default'] == "on") ? "t" : "f";
        $types = 'text';
  	  	$result = $_ENV['dbi']->extended->autoExecute("group_field_values",
          $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
  	  } else {
  	  	foreach ($_POST['field_value'] as $idx => $value) {
  	  	  if (!empty($value)) {
            $insert = array();
            $types = array();

  	  		  $insert['gfid'] = $_POST['gfid'];
            $types = 'integer';
  	  		  $insert['value_idx'] = $idx+1;
            $types = 'integer';
  	  		  $insert['value'] = $value;
            $types = 'text';
  	  		  $insert['is_default'] = ($_POST['default'] == $idx) ? "t" : "f";
            $types = 'text';
  	  		  $result = $_ENV['dbi']->extended->autoExecute("group_field_values",
                $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
            $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  	  	  }
  	  	}
  	  }
  	  redirect("?module=groups&action=edit_group_fields&gid=".$_GET['gid']);
  	} else {
  	  $_ENV['error']->push_error(_("Invalid access method"));
  	}
  } elseif ($_GET['subaction'] == "edit" and !empty($_GET['id'])) {
    if ($_POST['commit'] == "true") {
      if (empty($_POST['field_name'])) {
        $_ENV['error']->push_error(_("Field Name cannot be empty."));
      } else
      if (empty($_POST['field_type'])) {
        $_ENV['error']->push_error(_("Field Type must be selected."));
      } else {
        $name = strtolower(str_replace(" ", "_", $_POST['field_name']));

        $update = array();
        $types = array();
        $update['typeid'] = $_POST['field_type'];
        $types[] = 'integer';
        $update['name']   = $name;
        $types[] = 'text';
        $update['label']  = ucwords(str_replace("_", " ", $name));
        $types[] = 'text';
        $result = $_ENV['dbi']->extended->autoExecute("group_fields",
          $update,
          MDB2_AUTOQUERY_UPDATE,
          sprintf("gfid=%s", $_ENV['dbi']->quote($_GET['id'], 'integer')),
          $types); 
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
         
        redirect("?module=groups&action=edit_group_fields&gid=".$_GET['gid']);
      }
    }

    if (empty($_POST['commit']) or $_ENV['error']->errors_pending()) {
      $stmt = $_ENV['dbi']->prepare("SELECT typeid,name from group_fields WHERE gfid=?");
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($_GET['id']));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $field = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
      $result->free();
      $stmt->free();
      
      $stmt = $_ENV['dbi']->prepare("SELECT typeid,name FROM custom_field_types ORDER BY name");
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute();
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      $custom_types = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
      $result->free();
      $stmt->free();
      
      $_ENV['tpl']->assign('field',$field);
	  $_ENV['tpl']->assign('custom_types',$custom_types);
      $_ENV['tpl']->display("groups/group_fields/edit.tpl");
    }
  } else {
    $sql  = "SELECT g.gfid,g.name,cft.name AS type ";
    $sql .= "FROM group_fields AS g ";
    $sql .= "JOIN custom_field_types AS cft ON cft.typeid=g.typeid ";
    $sql .= "WHERE g.gid=? ";
    $sql .= "ORDER BY g.name";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($_GET['gid']));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $group_fields = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    
    $stmt = $_ENV['dbi']->prepare("SELECT typeid,name FROM custom_field_types ORDER BY name");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $custom_types = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    
    $_ENV['tpl']->assign('group_fields',$group_fields);
    $_ENV['tpl']->assign('custom_types',$custom_types);
    $_ENV['tpl']->display("groups/group_fields/view.tpl");
  }
} else {
  redirect();
}
?>
