<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to edit group info."));
  redirect();
}

if ($_GET['submit'] == "true") {
	if (empty($_POST['gname'])) {
    $_ENV['error']->push_error(_("Group name can not be blank."));
	} else if (!empty($_POST['bought']) and eregi('[^0-9]',$_POST['bought'])) {
    $_ENV['error']->push_error(_("Please enter a numerical value for amount purchased."));
	} else if (!empty($_POST['amount']) and eregi('[^0-9\.]',$_POST['amount'])) {
    $_ENV['error']->push_error(_("Please enter a numerical value for contract amount. [#.##]"));
  } else if (!empty($_POST['emailaddy']) and !ereg("[TID]",$_POST['notes'])) {
    $_ENV['error']->push_error(_("When using an email address the notes field must contain the string [TID] for the acknowledgment message."));
  }

  if ($_POST['startdate']) {
    $sdate = $_ENV['i18n']->parse_datetime($_POST['startdate']);
    if (!$sdate) {
      $_ENV['error']->push_error(_("Invalid start date."));
    }
  } else {
    $sdate = null;
  }

  if ($_POST['enddate']) {
    $edate = $_ENV['i18n']->parse_datetime($_POST['enddate']);
    if (!$edate) {
      $_ENV['error']->push_error(_("Invalid end date."));
    }
  } else {
    $edate = null;
  }
  if (!$_ENV['error']->errors_pending()) {
    $update = array();
    $types = array();

    if ($_POST['gname'] != group_name($_GET['gid'])) {
	$update["name"] = $_POST['gname'];
	$types[] = 'text';
    }
    $update['address']	= $_POST['address'];
    $types[] = 'text';
    $update['address2']	= $_POST['address2'];
    $types[] = 'text';
    $update['contact']	= $_POST['pcontact'];
    $types[] = 'text';
    $update['tech']	= $_POST['tcontact'];
    $types[] = 'text';
    $update['tao']	= $_POST['tao'];
    $types[] = 'text';
    $update['brm']	= $_POST['brm'];
    $types[] = 'text';
    $update['sales']	= $_POST['sales'];
    $types[] = 'text';
    $update['amount']	= !empty($_POST['amount']) ? $_POST['amount'] : 0;
    $types[] = 'integer';
    $update['bought']    = !empty($_POST['bought']) ? $_POST['bought'] : 0;
    $types[] = 'integer';
    $update['start_date'] = $sdate;
    $types[] = 'text';
    $update['end_date']	= $edate;
    $types[] = 'text';
    $update['notes']    = $_POST['notes'];
    $types[] = 'text';
    $update['status_reports'] = $_POST['statusreports'] == "on" ? "t" : "f";
    $types[] = 'text';
    $update['active']	= $_POST['active'] == "on" ? "t" : "f";
    $types[] = 'text';
    $update['group_type'] = $_POST['grouptype'];
    $types[] = 'text';

    if(is_admin($_SESSION['userid'])){
      $update['email']   = $_POST['emailaddy'];
      $types[] = 'text';
    }

		$result = $_ENV['dbi']->extended->autoExecute("groups",
      $update,
      MDB2_AUTOQUERY_UPDATE,
      sprintf("gid=%s", $_ENV['dbi']->quote($_GET['gid'], 'integer')),
      $types); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

    gen_cache("groups","gid","name");
    
		redirect("?module=groups&action=view&gid=".$_GET['gid']);
	}
}

$links[] = array(
  "txt" => _("Back to Group Information"),
  "url" => "?module=groups&action=view&gid=".$_GET['gid'],
  "img" => $_ENV['imgs']['back']
);

// from query to pull group info
$sql  = "SELECT * ";
$sql .= "FROM groups ";
$sql .= "WHERE gid=? ";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$group = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
if (is_null($group)) {
  redirect();
}
$_ENV['tpl']->assign('group',$group);

$_ENV['tpl']->display("groups/edit_info.tpl");
?>
