<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['gid'])) {
  redirect("?modules=groups");
}

if (!is_employee()
or !permission_check("update_group",$_GET['gid'])) {
  $_ENV['error']->push_error(_("You do not have permission to edit subgroups."));
  redirect();
}

$links[] = array(
  "txt" => _("Back to Group Information"),
  "url" => "?module=groups&action=view&gid=".$_GET['gid'],
  "img" => $_ENV['imgs']['back']
);

$props = array(
  "prop_user",
  "prop_category",
  "prop_product",
  "prop_status",
  "prop_announce",
  "prop_issue"
);
$sql_props = implode(",",$props);
$_ENV['tpl']->assign('props',$props);

// make sure $_GET['prop'] is clean
if (isset($_GET['prop']) && !in_array($_GET['prop'], $props)) {
  $_ENV['error']->push_error("Invalid propagation");
  redirect("?module=groups&action=view&gid=" . ($_GET['gid']+0));
  exit;
}

if ($_GET['do'] == "remove" and !empty($_GET['child'])) {
  if ($_POST['confirm'] == "true") {
    $result = $_ENV['dbi']->extended->autoExecute("sub_groups",
      null,
      MDB2_AUTOQUERY_DELETE,
      "parent_gid=" . $_ENV['dbi']->quote($_GET['gid'], "integer") . " AND " .
      "child_gid=" . $_ENV['dbi']->quote($_GET['child'], "integer")); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  } else {
    $_ENV['tpl']->display("groups/sub_groups/remove.tpl");
  }
} else if ($_GET['do'] == "toggle_parent" and !empty($_GET['prop'])) {
  $stmt = $_ENV['dbi']->prepare("SELECT {$_GET['prop']} from groups where gid=?");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['gid']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $prop = $result->fetchOne(); 
  $result->free();
  $stmt->free();

  $update = array();
  $types = array();
  $update[$_GET['prop']] = $prop == "t" ? "f" : "t";
  $types[] = 'text';
  $result = $_ENV['dbi']->extended->autoExecute("groups",
    $update,
    MDB2_AUTOQUERY_UPDATE,
    sprintf("gid=%s", $_ENV['dbi']->quote($_GET['gid'], 'integer')),
    $types); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
} else if ($_GET['do'] == "toggle_child" and !empty($_GET['child']) and !empty($_GET['prop'])) {
  $stmt = $_ENV['dbi']->prepare("SELECT {$_GET['prop']} from sub_groups where parent_gid=? and child_gid=?");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['gid'], $_GET['child']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $prop = $result->fetchOne(); 
  $result->free();
  $stmt->free();

  $update = array();
  $types = array();
  $update[$_GET['prop']] = $prop == "t" ? "f" : "t";
  $types[] = 'text';
  $result = $_ENV['dbi']->extended->autoExecute("sub_groups",
    $update,
    MDB2_AUTOQUERY_UPDATE,
    sprintf("parent_gid=%s and child_gid=%s", 
        $_ENV['dbi']->quote($_GET['gid'], 'integer'), 
        $_ENV['dbi']->quote($_GET['child'], 'integer')),
    $types); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  unset($update);
}

if (is_array($_POST['add_groups']) and @count($_POST['add_groups']) > 0) {
  foreach ($_POST['add_groups'] as $child) {
    $insert = array();
    $types = array();

    $insert['parent_gid'] = $_GET['gid'];
    $types[] = 'integer';
    $insert['child_gid']  = $child;
    $types[] = 'integer';
    $result = $_ENV['dbi']->extended->autoExecute("sub_groups",
      $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  }
}

$sql  = "SELECT parent_gid,$sql_props ";
$sql .= "FROM sub_groups ";
$sql .= "WHERE child_gid=? ";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$parent = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

if (!is_null($parent)) {
  $_ENV['tpl']->assign('parent',$parent);
  $_ENV['tpl']->assign('name',"Parent Group Propagation (Not Editable): ".group_name($parent['parent_gid']));
  $_ENV['tpl']->display("groups/sub_groups/parent.tpl"); 
}

$sql  = "SELECT $sql_props ";
$sql .= "FROM groups ";
$sql .= "WHERE gid=? ";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$current = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
if (!is_null($current)) {
  $_ENV['tpl']->assign('current',$current);
  $_ENV['tpl']->assign('name',group_name($_GET['gid'])." Propagation");
  $_ENV['tpl']->display("groups/sub_groups/group.tpl");
}

$sql  = "SELECT g.name,s.child_gid,s.prop_user,s.prop_category,s.prop_product,s.prop_status,s.prop_announce,s.prop_issue ";
$sql .= "FROM groups g, sub_groups s ";
$sql .= "WHERE s.parent_gid=? ";
$sql .= "AND g.gid = s.child_gid ";
$sql .= "ORDER BY g.name";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$children = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

$_ENV['tpl']->assign('children',$children);
$_ENV['tpl']->display("groups/sub_groups/children.tpl");

$_ENV['tpl']->assign('possible',possible_children($_GET['gid']));
$_ENV['tpl']->display("groups/sub_groups/add.tpl");
?>
