<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['gid'])) {
  redirect("?modules=groups");
}

//Changed 7/19/2004: from !is_admin()
if (!is_employee() && !permission_check("update_group",$_GET['gid'])) {
  $_ENV['error']->push_error(_("You do not have permission to edit issue visibility."));
  redirect();
}

$links[] = array(
  "txt" => _("Back to Group Information"),
  "url" => "?module=groups&action=view&gid=".$_GET['gid'],
  "img" => $_ENV['imgs']['back']
);

if (is_array($_POST['add_groups']) and @count($_POST['add_groups']) > 0) {
  foreach ($_POST['add_groups'] as $child) {
    group_visibility_add($_GET['gid'],$child);
  }
}

if (is_array($_POST['del_groups']) and @count($_POST['del_groups']) > 0) {
  foreach ($_POST['del_groups'] as $child) {
    group_visibility_del($_GET['gid'],$child);
  }
}

if (is_array($_POST['add_groups_write']) and @count($_POST['add_groups_write']) > 0) {
  foreach ($_POST['add_groups_write'] as $child) {
    group_visibility_add($_GET['gid'],$child,'t');
  }
}

if (is_array($_POST['del_groups_write']) and @count($_POST['del_groups_write']) > 0) {
  foreach ($_POST['del_groups_write'] as $child) {
    group_visibility_del($_GET['gid'],$child,'t');
  }
}

// Select read-only viewers.
$sql  = "SELECT v.viewer_gid AS gid,g.name ";
$sql .= "FROM group_issue_visibility AS v ";
$sql .= "JOIN groups AS g ON g.gid=v.viewer_gid ";
$sql .= "WHERE v.owner_gid=? ";
$sql .= "AND can_write='f' ";
$sql .= "ORDER BY g.name";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$viewers = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

// Select read/write viewers.
$sql  = "SELECT v.viewer_gid AS gid,g.name ";
$sql .= "FROM group_issue_visibility AS v ";
$sql .= "JOIN groups AS g ON g.gid=v.viewer_gid ";
$sql .= "WHERE v.owner_gid=? ";
$sql .= "AND can_write='t' ";
$sql .= "ORDER BY g.name";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$writers = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

$_ENV['tpl']->assign('viewers',$viewers);
$_ENV['tpl']->assign('writers',$writers);
$_ENV['tpl']->assign('possible',possible_viewer_groups($_GET['gid']));
$_ENV['tpl']->display("groups/issue_visibility/view.tpl");
?>
