<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to create a group."));
  redirect();
}

if (!empty($_POST['gname'])) {
  // make sure a group name was given
  if (empty($_POST['gname'])) {
    $_ENV['error']->push_error(_("Please enter a name for this group"));
  }
  if (!empty($_POST['amount']) and !ereg('[0-9\.]{1,}',$_POST['amount'])) {
    $_ENV['error']->push_error(_("Invalid value given for amount, please exclude commas. (#.##)"));
  }

  $sql  = "SELECT gid ";
  $sql .= "FROM groups ";
  $sql .= "WHERE LOWER(name)=LOWER(?) ";
  $stmt = $_ENV['dbi']->prepare($sql); 
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_POST['gname']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  if ($result->numRows() > 0) {
    $_ENV['error']->push_error(_("This group name is already taken."));
  }
  $result->free();
  $stmt->free();

  if ($_POST['startdate']) {
    $sdate = $_ENV['i18n']->parse_datetime($_POST['startdate']);
    if (!$sdate) {
      $_ENV['error']->push_error(_("Invalid start date."));
    }
  } else {
    $sdate = null;
  }

  if ($_POST['enddate']) {
    $edate = $_ENV['i18n']->parse_datetime($_POST['enddate']);
    if (!$edate) {
      $_ENV['error']->push_error(_("Invalid end date."));
    }
  } else {
    $edate = null;
  }

  if (!$_ENV['error']->errors_pending()) {
    $insert = array();
    $types = array();
    $insert['name'] = $_POST['gname'];
    $types[] = 'text';
    $insert['address'] = $_POST['address'];
    $types[] = 'text';
    $insert['address2'] = $_POST['address2'];
    $types[] = 'text';
    $insert['contact'] = $_POST['pcontact'];
    $types[] = 'text';
    $insert['tech'] = $_POST['tcontact'];
    $types[] = 'text';
    $insert['tao'] = $_POST['tao'];
    $types[] = 'text';
    $insert['brm'] = $_POST['brm'];
    $types[] = 'text';
    $insert['sales'] = $_POST['sales'];
    $types[] = 'text';
    $insert['amount'] = !empty($_POST['amount']) ? $_POST['amount'] : 0;
    $types[] = 'integer';
    $insert['bought'] = !empty($_POST['bought']) ? $_POST['bought'] : 0;
    $types[] = 'integer';
    if ($sdate) {
      $insert['start_date'] = $sdate;
      $types[] = 'text';
    }
    if ($edate) {
      $insert['end_date'] = $edate;
      $types[] = 'text';
    }
    if (!empty($_POST['type'])) {
      $insert['group_type'] = $_POST['grouptype'];
      $types[] = 'text';
    }
    $insert['email'] = $_POST['emailaddy'];
    $types[] = 'text';
    $insert['notes'] = $_POST['notes'];
    $types[] = 'text';

    // insert new group into datbase
    $result = $_ENV['dbi']->extended->autoExecute("groups",
      $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

    $gid = dbi_last_insert_id_fix("groups", "gid");

    if (!empty($gid)) {
      group_useradd($_SESSION['userid'],$gid);

      $result = $_ENV['dbi']->extended->autoExecute("group_users",
        array("perm_set" => PSET_GADMIN),
        MDB2_AUTOQUERY_UPDATE,
        sprintf("gid=%s and userid=%s", 
                $_ENV['dbi']->quote($gid, 'integer'), 
                $_ENV['dbi']->quote($_SESSION['userid'], 'integer')),
        array('integer')); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      unset($update);
      session_register('GROUP_WIZARD');
      $_SESSION['GROUP_WIZARD'] = TRUE;
      gen_cache("groups","gid","name");
      redirect("?module=groups&action=edit&type=categories&gid=$gid");
    } else {
      $_ENV['error']->push_error(sprintf(_("This group could not be created. Please contact %s for assistance"), $_ENV['config']['email']['admin']));
    }
  }
}

$links[] = array(
  "txt" => _("Back to Groups"),
  "url" => "?module=groups",
  "img" => $_ENV['imgs']['back']
);

$_ENV['tpl']->display("groups/new.tpl");
?>
