<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!group_exists($_GET['gid'])) {
  redirect();
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to view this group."));
  redirect();
}


// Make sure to clean the wizard session variable
// or it could cause a nasty loop
unset($_SESSION['GROUP_WIZARD']);

$stmt = $_ENV['dbi']->prepare("SELECT count(*) from group_products");
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array());
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$count = $result->fetchOne(); 
$result->free();
$stmt->free();
if (!$count || $count < 1) {
  $_ENV['error']->push_error(_("Must have at least one product defined."));
  redirect("?module=groups&action=edit&type=products&gid=".$_GET['gid']);
}

// check to make sure at least one status is defined
$stmt = $_ENV['dbi']->prepare("SELECT count(*) from group_statuses");
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array());
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$count = $result->fetchOne(); 
$result->free();
$stmt->free();

if (!$count || $count < 1) {
  $_ENV['error']->push_error(_("Must have at least one status defined."));
  redirect("?module=groups&action=edit&type=statuses&gid=".$_GET['gid']);
}
// from query to pull group info
$sql  = "SELECT * ";
$sql .= "FROM groups ";
$sql .= "WHERE gid=? ";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['gid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$group = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
if (is_null($group)) {
  redirect();
}
$_ENV['tpl']->assign('group',$group);

$links[] = array(
  "txt" => _("Back to Groups"),
  "url" => "?module=groups",
  "img" => $_ENV['imgs']['back']
);
      
if (permission_check("update_group",$_GET['gid'])) {
  $links[] = array(
    "txt" => _("Edit Information"),
    "url" => "?module=groups&action=edit_info&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['edit']
  );

  if (is_admin()) {
    $links[] = array(
      "txt" => _("Email"),
      "url" => "?module=groups&action=edit_email&gid=".$_GET['gid'],
      "img" => $_ENV['imgs']['email']
    );
  }

  $links[] = array(
    "txt" => _("Add/Remove Users"),
    "url" => "?module=groups&action=edit_users&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['user']
  );

  $links[] = array(
    "txt" => _("Sub Groups"),
    "url" => "?module=groups&action=edit_sub_groups&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['group']
  );

  $links[] = array(
    "txt" => _("Permissions"),
    "url" => "?module=groups&action=edit_permissions&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['permission']
  );

  $links[] = array(
    "txt" => _("Escalations"),
    "url" => "?module=groups&action=edit&type=escalation&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['escalate']
  );

  $links[] = array(
    "txt" => _("Statuses"),
    "url" => "?module=groups&action=edit&type=statuses&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['status']
  );

  $links[] = array(
    "txt" => _("Internal Statuses"),
    "url" => "?module=groups&action=edit&type=istatuses&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['status']
  );

  $links[] = array(
    "txt" => _("Categories"),
    "url" => "?module=groups&action=edit&type=categories&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['category']
  );

  $links[] = array(
    "txt" => _("Products"),
    "url" => "?module=groups&action=edit&type=products&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['product']
  );
  
  $links[] = array(
    "txt" => _("Issue Reassignment"),
    "url" => "?module=groups&action=edit_assign_groups&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['group']
  );
  
  $links[] = array(
    "txt" => _("Issue Visibility"),
    "url" => "?module=groups&action=issue_visibility&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['group']
  );

  $links[] = array(
     "txt" => _("Unassigned Exclude"),
     "url" => "?module=groups&action=edit_exclude_unassigned&gid=".$_GET['gid'],
     "img" => $_ENV['imgs']['unsubscribe']
   );

}
//Changed 7/27/2004: trying to get this right.
if (permission_check("update_group",$_GET['gid']) && permission_check("field_manager", $_GET['gid'])) {
  $links[] = array(
    "txt" => _("Group-Defined Fields"),
    "url" => "?module=groups&action=edit_group_fields&type=fields&gid=".$_GET['gid'],
    "img" => $_ENV['imgs']['field']
  );
}
$members = group_members($_GET['gid']);
$_ENV['tpl']->assign('members',$members);
$_ENV['tpl']->display("groups/view.tpl");

?>
