<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['issueid'])) {
  redirect();
}

$issue = &get_issue($_GET['issueid']);

$issue_gids = $issue->enumerate_groups();

// determine through which groups this user can view the issue
$ugroups = array();
foreach ($issue_gids as $gid) {
  if (in_array($gid, $_SESSION['groups'])) {
    $issuegroup = $issue->group($gid);
    if ($issuegroup->show_issue()) {
  	  array_push($ugroups,$gid);
    }
  }
}

// take different action depending on how many results we got
if (count($ugroups) > 1) {
  // we have a selection of groups -- show the form

  $ugroup_names = array();
  foreach ($ugroups as $gid) {
    $ugroup_names[$gid] = group_name($gid);
  }

  $_ENV['tpl']->assign('ugroup_names',$ugroup_names);
  $_ENV['tpl']->display("issues/choose_view_group.tpl");
} else if (count($ugroups) == 1) {
  // there's a single acceptable group, so use it
  $gid = $ugroups[0];
  redirect("?module=issues&action=view&issueid={$_GET['issueid']}&gid=$gid");
} else {
  // a little bit of a lie, just so as not to give away the game
	push_error(_("Could not find that issue in the database."));
	redirect("?module=issues");
}
?>
