<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

// XXX $_GET['gid'] is not set, so this is stupid
if (!permission_check("technician",$_GET['gid'])) {
	redirect("?module=issues&action=view&issueid=".$_GET['issueid']."&gid=".$_GET['gid']);
}

if (empty($_GET['issueid'])
or !issue_exists($_GET['issueid'])) {
  redirect("?module=issues");
}

if (!empty($_POST['address'])) {
  $stmt = $_ENV['dbi']->prepare("SELECT severity,opened_by FROM issues WHERE issueid=?");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['issueid']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
	list($severity,$opened_by) = $result->fetchRow(MDB2_FETCHMODE_ORDERED); 
  $result->free();
  $stmt->free();

  $subject = "Issue Tracker Issue #".$_GET['issueid'];
	$message  = "Summary:     ".$_POST['subject']."\n";
	$message .= "Opened By:   ".username($opened_by)."\n";
	$message .= "Severity:    ".severity_text($severity)."\n\n";
	$message .= "Problem:\n".urldecode($_POST['problem'])."\n\n";

  if (isset($_POST['eids']) && is_array($_POST['eids'])) {
    $events = array();
    foreach ($_POST['eids'] as $eid) { $events[] = $eid+0; } // santize to an integer
    $events = implode(",",$events);
    $sql  = "SELECT action,userid,performed_on ";
    $sql .= "FROM events ";
    $sql .= "WHERE eid IN ($events) "; // safe; see above
    $sql .= "ORDER BY performed_on DESC";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
    $events = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    foreach ($events as $event) {
			$message .= "****** Event by ".username($event['userid'])." (".$_ENV['i18n']->format_datetime($event['performed_on']).") ******\n\n";
			$message .= $event['action']."\n\n";
		}
	}

	$message .= "\n\n\n-------------------------\nIssue can be found at:\n";
	$message .= _URL_."/?module=issues&action=view&issueid=".$_GET['issueid']."\n";
	$message .= $_ENV['config']['email']['admin'];
	$message = $message;

  // Make sure we have mailer class and initialize it
  include_once(_CLASSES_."mail.class.php");
  if (!is_object($mailer)) {
    $mailer = new MAILER();
    $mailer->set("email_from",$_ENV['config']['email']['sender']);
  }
  $mailer->subject($subject);
  $mailer->to($_POST['address']);
  $mailer->message($message);
  $mailer->send();
  redirect("?module=issues&action=view&issueid=".$_GET['issueid']);
}

$links[] = array(
  "txt" => _("Back to Issue"),
  "url" => "?module=issues&action=view&issueid=".$_GET['issueid'],
  "img" => $_ENV['imgs']['back']
);
 
$stmt = $_ENV['dbi']->prepare("SELECT problem,summary FROM issues WHERE issueid=?");
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['issueid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
list($problem,$summary) = $result->fetchRow(MDB2_FETCHMODE_ORDERED); 
$result->free();
$stmt->free();

$_ENV['tpl']->assign('problem',$problem);
$_ENV['tpl']->assign('summary',$summary);

$sql  = "SELECT eid,action,userid ";
$sql .= "FROM events ";
$sql .= "WHERE issueid=? ";
$sql .= "ORDER BY performed_on";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_GET['issueid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$events = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

$_ENV['tpl']->assign('events',$events);
$_ENV['tpl']->display("issues/email.tpl");
?>
