<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

// make sure gid is not empty, if it is then make the user go back and
// choose which groups issues they want to see
if(empty($_GET['gid'])){
	redirect("?module=groups");
} else {
	if (permission_check("create_issues",$_GET['gid'])) {
    $links[] = array(
      "img" => $_ENV['imgs']['new_issue'],
      "txt" => _("Create Issue"),
      "url" => "?module=issues&action=new&gid=".$_GET['gid']
    );
  }

  if($_GET['showall'] != "true"){
    $links[] = array(
      "img" => $_ENV['imgs']['show_closed'],
      "txt" => _("Show Closed"),
      "url" => "?module=issues&action=group&showall=true&gid=".$_GET['gid']
    );
  } else {
    $links[] = array(
      "img" => $_ENV['imgs']['hide_closed'],
      "txt" => _("Hide Closed"),
      "url" => "?module=issues&action=group&showall=false&gid=".$_GET['gid']
    );
  }

  // Make sure we have something to sort by
  if (empty($_GET['sort'])) {
    if (empty($_SESSION['prefs']['sort_by']))
       $_GET['sort'] = "status";
    else
       $_GET['sort'] = $_SESSION['prefs']['sort_by'];
}

  //Fix the x,y unparseable GID problem.
  if (strpos($_GET['gid'], ",") !== false) {
    $gids = explode(",", $_GET['gid']);
    $rows = array();
    foreach ($gids as $gid) {
      array_merge($rows, group_issues($gid));
    }
  } else {
    $rows = group_issues($_GET['gid']);
  }

  $show_private = permission_check("view_private",$_GET['gid']);
  foreach ($rows as $key => $val) {
    $rows[$key]['unread'] = unread_events($key,$_SESSION['userid'],$show_private);
    $rows[$key]['escto'] = issue_escalated_to($key,$_GET['gid']);
    $rows[$key]['escfrom'] = issue_escalated_from($key,$_GET['gid']);
  }
  $num_rows = count($rows);
  $colspan = count($_SESSION['prefs']['show_fields']) + 2;
  $title = _("Issues")." :: ".group_name($_GET['gid'])." (".sprintf(_("Displaying %s Issues"),$num_rows).")";
  // Send current date to template, used in due date column
  $_ENV['tpl']->assign('now',time());

  $_ENV['tpl']->assign('colspan',$colspan);
  $_ENV['tpl']->assign('title',$title);
  $_ENV['tpl']->assign('rows',$rows);
  $_ENV['tpl']->assign('num_rows',$num_rows);

  $url  = "?module=issues&action=group&gid=".$_GET['gid'];
  $url .= $_GET['showall'] == "true" ? "&showall=true" : "";
  $url .= $_GET['reverse'] != "true" ? "&reverse=true" : "";
  $_ENV['tpl']->assign('url',$url);

  $_ENV['tpl']->display("issues/group.tpl");
}
?>
