<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

list($registered) = fetch_status(TYPE_REGISTERED);
$closed = implode(",",fetch_status(array(TYPE_CLOSED,TYPE_AUTO_CLOSED)));

if (is_employee($_SESSION['userid'])) {
  $group_status = array();
  $group_view   = array();
  
  foreach ($_SESSION['groups'] as $gid)
  {
  	// check if group is active.  Only display active groups
  	// John Wells - 01/19/2003
    $stmt = $_ENV['dbi']->prepare("SELECT count(*) from groups where gid=? and active='t'");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($gid));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  	$count = $result->fetchOne(); 
    $result->free();
    $stmt->free();
    
    if ($count > 0)
    { 
      $group_status[$gid] = group_summary($gid);
      
      // Check for active visible groups. For issue visibility.
      // Dave Joyce - 7/27/2004
      $sql  = "SELECT v.owner_gid,g.name,v.can_write ";
      $sql .= "FROM group_issue_visibility AS v ";
      $sql .= "JOIN groups AS g ON g.gid=v.owner_gid ";
      $sql .= "WHERE viewer_gid=? ";
      $sql .= "ORDER BY g.name";
      $stmt = $_ENV['dbi']->prepare($sql); 
      $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
      $result = $stmt->execute(array($gid));
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
      while($row = $result->fetchRow(MDB2_FETCHMODE_ASSOC)) {
        if(!array_key_exists($row['owner_gid'], $group_view)){
          $group_view[$row['owner_gid']] = array("name" => $row['name'],"type" => $row['can_write']);
        }
  
        $vis_group_summary = group_summary($row['owner_gid']);
          
        $group_view[$row['owner_gid']] = array_merge($group_view[$row['owner_gid']], $vis_group_summary);
      }      
      $result->free();
      $stmt->free();
    }
  }
  $_ENV['tpl']->assign('group_status',$group_status);
  $_ENV['tpl']->display("issues/group_status_miniview.tpl");
  
  // Display visible (non-member) groups.
  // Dave Joyce - 7/27/2004
  if(count($group_view) > 0){
  	$_ENV['tpl']->assign('group_view',$group_view);
  	$_ENV['tpl']->display("issues/group_visibility_miniview.tpl");
  }
}

$ugroups = implode(",",$_SESSION['groups']);
$sql  = "SELECT issueid,summary,modified,status,primary_gid ";
$sql .= "FROM issues ";
$sql .= "WHERE primary_gid IN ($ugroups) "; // safeish
$sql .= "AND status NOT IN ($closed) "; // safe: from fetch_status, above
$sql .= !is_employee($_SESSION['userid']) ? "AND private != 't' " : "";
$sql .= "ORDER BY modified DESC LIMIT 5";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute();
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
$_ENV['tpl']->assign('last_issues',$issues);

$sql  = "SELECT issueid,primary_gid,summary,modified,status ";
$sql .= "FROM issues ";
$sql .= "WHERE opened_by=? ";
$sql .= "AND status NOT IN ($closed) "; // safe: from fetch_status, above
$sql .= !is_employee($_SESSION['userid']) ? "AND private != 't' " : "";
$sql .= "ORDER BY modified DESC LIMIT 5";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_SESSION['userid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
$_ENV['tpl']->assign('opened_issues',$issues);

$sql  = "SELECT t.issueid,t.primary_gid,t.summary,t.modified,t.status ";
$sql .= "FROM issues t, issue_groups g ";
$sql .= "WHERE g.assigned_to=? ";
$sql .= "AND t.status NOT IN ($closed) "; // safe: from fetch_status, above
$sql .= "AND t.issueid = g.issueid ";
$sql .= "ORDER BY t.modified DESC LIMIT 5";
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute(array($_SESSION['userid']));
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();
$_ENV['tpl']->assign('assigned_issues',$issues);

$_ENV['tpl']->display("issues/miniview.tpl");
?>
