<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if($_GET['showall'] != "true"){
  $links[] = array(
    "img" => $_ENV['imgs']['show_closed'],
    "txt" => _("Show Closed"),
    "url" => "?module=issues&action=my_assigned&showall=true&gid=".$_GET['gid']
  );
} else {
  $links[] = array(
    "img" => $_ENV['imgs']['hide_closed'],
    "txt" => _("Hide Closed"),
    "url" => "?module=issues&action=my_assigned&showall=false&gid=".$_GET['gid']
  );
}

// retrieve needed statuses
list($registered) = fetch_status(TYPE_REGISTERED);
$closed = implode(",",fetch_status(array(TYPE_CLOSED,TYPE_AUTO_CLOSED)));

// Make sure we have something to sort by
if (empty($_GET['sort'])) {
  if (empty($_SESSION['prefs']['sort_by']))
        $_GET['sort'] = "status";
  else
        $_GET['sort'] = $_SESSION['prefs']['sort_by'];
}

$url  = "?module=issues&action=my_assigned$show$reverse";
$url .= $_GET['showall'] == "true" ? "&showall=true" : "";
$url .= $_GET['reverse'] == "true" ? "&reverse=true" : "";
$_ENV['tpl']->assign('url',$url);

// Send current date to template, used in due date column
$_ENV['tpl']->assign('now',time());

$order = "ASC";
if ($_GET['reverse'] == "true") {
  $order = "DESC";
}

// now show the rest of the issues
$params = array();
$sql  = "SELECT i.issueid, i.opened_by, i.modified, i.summary";
$sql .= ", i.due_date, i.status, i.category, i.product, i.severity, i.flags ";
$sql .= ", i.adjusted_by, i.opened, g.assigned_to, gr.name as gname, g.gid ";
$sql .= "FROM issues i, issue_groups g, groups gr ";
$sql .= $_GET['sort'] == "opened_by" ? ",users u " : " ";
$sql .= "WHERE g.assigned_to=? ";
$params[] = $_SESSION['userid'];
$sql .= $_GET['showall'] != "true" ? "AND i.status NOT IN ($closed) " : ""; // safe: from fetch_status, above
//$sql .= "AND i.issueid=g.issueid AND g.show_issue = 'f' ";
$sql .= "AND i.issueid=g.issueid AND g.show_issue = 't' AND g.gid=gr.gid ";

$sort = preg_replace('/[^a-zA-Z0-9]/', '_', $_GET['sort']); // sanitize
switch ($_GET['sort']) {
	case "opened_by":
		$sql .= "AND u.userid=i.$sort ";
		$sql .= "ORDER BY u.username $order ";
		break;
	case "gid":
		$sql .= "ORDER BY g.gid $order ";
		break;
	case "assigned_to":
		$sql .= "ORDER BY g.assigned_to $order ";
		break;
	case "g_name":
		$sql .= "ORDER BY gr.name $order ";
		break;
	default:
		$sql .= "ORDER BY i.$sort $order ";
		break;
}
$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute($params);
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
$result->free();
$stmt->free();

$num_rows = count($issues);
$title = _("My Issues (Assigned) :: Issues ")." ( ".sprintf(_("%s"), $num_rows)." )";

$colspan = (count($_SESSION['prefs']['show_fields']) >= 12) ? 12 : count($_SESSION['prefs']['show_fields'])+2;
$_ENV['tpl']->assign('colspan',$colspan);
$_ENV['tpl']->assign('issues',$issues);
$_ENV['tpl']->assign('title',$title);
$_ENV['tpl']->assign('myname', ident($_SESSION['userid']));
$_ENV['tpl']->display("issues/my_assigned.tpl");
?>
