<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['gid']) and !empty($_POST['gid'])) {
  // add a parameter
  $gid = $_POST['gid'];

  // [11-15-2005] DAJ
  // persisting the icopy parameter, so that we
  // don't lose the copy action.
  $url = "?module=issues&action=new&gid=$gid";
  if (!empty($_GET['icopy'])) {
    $url .= "&icopy=" . $_GET['icopy'];
  }
  redirect($url);
}

$processed = false;

if (isset($_POST['create'])) {
  if (!permission_check("create_issues",$_GET['gid'])) {
    $_ENV['error']->push_error(_("You do not have permission to add an issue to this group."));
    redirect();
  }

  if (empty($_POST['summary'])) {
    $_ENV['error']->push_error(_("Please enter a summary."));
  } else if (empty($_POST['severity'])) {
    $_ENV['error']->push_error(_("Please select a severity."));
  } else if (empty($_POST['problem'])) {
    $_ENV['error']->push_error(_("Please enter a problem."));
  } else if (empty($_POST['product'])) {
    $_ENV['error']->push_error(_("Please choose a product."));
  }

  if (!empty($_POST['duedate'])) {
    $due_date = $_ENV['i18n']->parse_datetime($_POST['duedate']);
    if (!$due_date) {
      $_ENV['error']->push_error(_("Incorrectly formatted due date"));
    }
  } else {
    $due_date = null;
  }

  if (!$_ENV['error']->errors_pending()) {
    $issue = add_new_issue($_SESSION['userid'], $_GET['gid'], $_POST['summary'], $_POST['problem'], $_POST['severity']);
    $issue->product($_POST['product']);
    if ($_POST['category']) { $issue->category($_POST['category']); }
    $issue->severity($_POST['severity']);
    if (isset($_POST['private'])) { $issue->is_private($_POST['private']); }
    if ($due_date) { $issue->due_date($due_date); }

    $issueid = $issue->issueid();
    $gid = $_GET['gid'];
    
    // handle an upload file
    if (isset($_FILES['upload']['name'])) {
        /*
        $upload = $_FILES['upload'];  
        $size = round((_MAXUPLOAD_ / 1024) / 1024,2);
    
        if ($upload['size'] > _MAXUPLOAD_ and !is_admin($_SESSION['userid'])) {
            $_ENV['error']->push_error(sprintf(_("Attached file exceeds size limit (%s MB)."), $size));
        }
        */
            
        $fids = array();
        if (!empty($_FILES['upload']['name'])) {
            $fids = upload($issueid);
        }
    }

    // Added by David Trejos - Gridshield (david@gridshield.net)
    // Save values for custom fields
    if (isset($_SESSION['custom_fields']) && is_array($_SESSION['custom_fields']) && count($_POST) > 0) {
       foreach ($_SESSION['custom_fields'] as $gfid => $info) {
          if(array_key_exists($info['name'], $_POST) && !empty($_POST[$info['name']])){
             $insert = array();
             $types = array();
             $insert['issueid']      = $issueid;
             $types[] = 'integer';
             $insert['gfid']         = $gfid;
             $types[] = 'integer';
             if(substr($info['type'], 0, 6) == "select") {
                 $insert['value_idx'] = $_POST[$info['name']];
                 $types[] = 'integer';
             } else {
                 $insert['value'] = $_POST[$info['name']];
                 $types[] = 'text';
             }
             $result = $_ENV['dbi']->extended->autoExecute("issue_group_fields",
                       $insert, MDB2_AUTOQUERY_INSERT, null, $types);
                       $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
          }
       }
    }

    $_GET['issueid'] = $issueid;
    include_once(_MODULES_."issues/view.issues.php");
    $processed = true;
  }
}

if (!$processed) { // done to stop executing this script as the creation of a ticket was processed
// Select a group
if (empty($_GET['gid'])) {
  $permitted_groups = array();
  foreach ($_SESSION['groups'] as $permitted_group) {
    if (permission_check("create_issues",$permitted_group)) { array_push($permitted_groups, $permitted_group); }
  }
  if (count($permitted_groups) > 1) {
    // many groups -> pick one
    $_ENV['tpl']->display("issues/choose_new.tpl");
  } elseif (count($permitted_groups) == 1) {
    // one group -> use that
    $gid = $permitted_groups[0];

    // [11-15-2005] DAJ
    // persisting the icopy parameter, so that we
    // don't lose the copy action.
    $url = "?module=issues&action=new&gid=$gid";
    if (!empty($_GET['icopy'])) {
        $url .= "&icopy=" . $_GET['icopy'];
    }
    redirect($url);
  } else {
    // no groups -> error
    $_ENV['error']->push_error(_("You don't have permission to create issues in any groups. Contact the administrator."));
    redirect();
  }
// We have a group
} else {
  if (permission_check("create_issues",$_GET['gid'])) {
    if (!empty($_GET['icopy'])) {
      if (can_view_issue($_GET['icopy'])) {
        $stmt = $_ENV['dbi']->prepare("SELECT summary,problem FROM issues WHERE issueid=?");
        $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
        $result = $stmt->execute(array($_GET['icopy']));
        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
        list($summary,$problem) = $result->fetchRow(MDB2_FETCHMODE_ORDERED); 
        $result->free();
        $stmt->free();

        if (!empty($summary)) {
          $_POST['summary'] = "(COPY) " . $summary;
          $_POST['problem'] = $problem;
        }
      }
    }

    $_ENV['tpl']->assign('products',group_products($_GET['gid']));
    $_ENV['tpl']->assign('categories', group_categories($_GET['gid']));
    $_ENV['tpl']->assign('members',group_members($_GET['gid']));

    //Added 07/09/2004: Get & parse group-defined fields, if any.
    $fields = group_fields($_GET['gid']);
    $custom_fields = "";
    foreach ($fields as $gfid => $field) {
      $_SESSION['custom_fields'][$gfid] = array('name' => $field['name'], 'type' => $field['type']);
      $_ENV['tpl']->assign("label", $field['label']);
      $_ENV['tpl']->assign("name", $field['name']);
      switch ($field['type']) {
        case "select":
        case "select multiple":
          $value_arr = group_field_values($gfid);
          $values = array();
          if(!is_null($value_arr)){
            foreach($value_arr as $idx => $arr){
              $values[$idx] = $arr['value'];
              if($arr['default'] == "t"){
                $def_value = $idx;
              }
            }
            $_ENV['tpl']->assign("values", $values);
            $_ENV['tpl']->assign("def_value", $def_value);
            $custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
            $_ENV['tpl']->clear_assign(array("label","name","values","def_value"));
            unset($value_arr);
          }
          break;
        case "checkbox":
        case "date":
        case "text":
        case "textarea":
          $value_arr = group_field_values($gfid);
          if (!empty($value_arr[0]['value'])) {
            $_ENV['tpl']->assign("value", $value_arr[0]['value']);
          }
          $custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
          $_ENV['tpl']->clear_assign(array("label","name","value"));
          unset($value_arr);
          break;
      }
    }
    $_ENV['tpl']->assign("custom_fields", !empty($custom_fields) ? $custom_fields : null);
    //End group-defined fields block.

    $_ENV['tpl']->display("issues/new.tpl");
  } else {
    $_ENV['error']->push_error(_("You don't have permission to create issues in this group."));
    redirect("?module=issues&action=new");
  }
}
}// processed
?>
