<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if ($_GET['advanced'] != "true"){
  $links[] = array(
    "img" => $_ENV['imgs']['search'],
    "txt" => _("Advanced Search"),
    "url" => "?module=issues&action=search&advanced=true"
  );
} else {
  $links[] = array(
    "img" => $_ENV['imgs']['search'],
    "txt" => _("Simple Search"),
    "url" => "?module=issues&action=search"
  );
}

// Only show the other options if we are doing an advanced search
if ($_GET['advanced'] == "true") {
  if (is_employee()) {
    $sql  = "SELECT gid ";
    $sql .= "FROM groups ";
    $sql .= "ORDER BY name";
    $stmt = $_ENV['dbi']->prepare("SELECT gid from groups order by name");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $ugroups = $result->fetchCol(); 
    $result->free();
    $stmt->free();

    $stmt = $_ENV['dbi']->prepare("SELECT userid,username FROM users ORDER BY username");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $u = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    foreach ($u as $user) {
      $users[$user['userid']] = $user['username'];
    }

    $stmt = $_ENV['dbi']->prepare("SELECT sid,status FROM statuses ORDER BY status");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $s = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    foreach ($s as $status) {
      $statuses[$status['sid']] = $status['status'];
    }
    
    $stmt = $_ENV['dbi']->prepare("SELECT cid,category FROM categories ORDER BY category");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $c = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    foreach ($c as $category) {
      $categories[$category['cid']] = $category['category'];
    }
    
    $stmt = $_ENV['dbi']->prepare("SELECT pid,product FROM products ORDER BY product");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $p = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    foreach ($p as $product) {
      $products[$product['pid']] = $product['product'];
    }
  } else {
    $ugroups = $_SESSION['groups'];

    foreach ($_SESSION['groups'] as $gid) {
      $members = group_members($gid);

      foreach ($members as $uid => $username) {
        if (!in_array($uid,$users)) {
          $users[$uid] = $username;
        }
      }
   
      $group_statuses = group_statuses($gid);

      foreach ($group_statuses as $sid => $status) {
        if (!array_key_exists($sid,$statuses)) {
          $statuses[$sid] = $status;
        }
      }

      $group_categories = group_categories($gid);

      foreach ($group_categories as $cid => $category) {
        if (!array_key_exists($cid,$categories)) {
          $categories[$cid] = $category;
        }
      }
      
      $group_products = group_products($gid);

      foreach ($group_products as $pid => $product) {
        if (!array_key_exists($pid,$products)) {
          $products[$pid] = $product;
        }
      }
    }
  }
  
  //Get group-defined fields for user groups.
  foreach ($ugroups as $gid) {
  	$fields = group_fields($gid);
    foreach ($fields as $gfid => $field) {
      $_SESSION['custom_fields'][$gfid] = array('name' => $field['name'], 'type' => $field['type']);
      $_ENV['tpl']->assign("label", $field['label']);
      $_ENV['tpl']->assign("name", $field['name']);
      switch ($field['type']) {
        case "select":
        case "select multiple":
          $value_arr = group_field_values($gfid);
          $values = array();
          if(!is_null($value_arr)){
            foreach($value_arr as $idx => $arr){
              $values[$idx] = $arr['value'];
      	    }
      	    $_ENV['tpl']->assign("values", $values);
      	    $custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
      	    $_ENV['tpl']->clear_assign(array("label","name","value","values","def_value"));
      	  }
      	  break;
      	case "checkbox":
      	case "date":
      	case "text":
      	case "textarea":
      	  $value_arr = group_field_values($gfid);
      	  if (!empty($curr_value)) {
      	    $_ENV['tpl']->assign("value", $curr_value);
      	  } elseif (!empty($value_arr[0]['value'])) {
      	    $_ENV['tpl']->assign("value", $value_arr[0]['value']);
      	  }
      	  $custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
      	  $_ENV['tpl']->clear_assign(array("label","name","value"));
      	  break;
      }
    }
  }
  $_ENV['tpl']->assign("custom_fields", !empty($custom_fields) ? $custom_fields : null);
  //End group-defined fields block.
  
  $_ENV['tpl']->assign('ugroups',$ugroups);
  $_ENV['tpl']->assign('users',$users);
  $_ENV['tpl']->assign('statuses',$statuses);
  $_ENV['tpl']->assign('categories',$categories);
  $_ENV['tpl']->assign('products',$products);
}

$_ENV['tpl']->display("issues/search.tpl");
?>
