<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['issueid'])) {
	redirect();
}

$issue = &get_issue($_GET['issueid']);

function get_post_array($name) {
  $rv = array();
  if (isset($_POST[$name])) {
    if (is_array($_POST[$name])) {
      $rv = $_POST[$name];
    } else {
      $rv = array($_POST[$name]);
    }
  }

  return $rv;
}

if (isset($_GET['submit'])) {
  $add_clients = get_post_array("add_clients");
  $del_clients = get_post_array("del_clients");
  $add_techs = get_post_array("add_techs");
  $del_techs = get_post_array("del_techs");

  // process the text field
  if (isset($_POST['add_clients_txt']) && trim($_POST['add_clients_txt'])) {
    foreach (explode('\n', trim($_POST['add_clients_txt'])) as $email) {
      $email = trim($email);
      $user = &get_user_by_email($email);
      if (!$user) {
        $user = create_user(array("primary_email" => $email));
      }

      $add_clients[] = $user->userid();
    }
  }

  // get the issue object
  $issue = &get_issue($_GET['issueid']+0);
  if (!$issue) { die("Issue not found"); }

  // and take action.  we remove first so that the adds will actually
  // happen.  add_client() and add_tech() abort if user already in either.
  foreach ($del_techs as $tech) { $issue->remove_tech($tech); }
  foreach ($del_clients as $client) { $issue->remove_client($client); }
  foreach ($add_clients as $client) { $issue->add_client($client); }
  foreach ($add_techs as $tech) { $issue->add_tech($tech); }

  redirect("?module=issues&action=subscribers&issueid=".$_GET['issueid']."&gid=".$_GET['gid']);
} else {
  // note these have different formats: enumerate_users returns an array
  // with 'ident' already in it, while $issue->clients/techs return a simple
  // array of idents.

  // By default only show the group members, 
  // if the user select [show all], will show all the users	
  if ($_GET['all_clients']) {
      $clients = enumerate_users(true);
  } else {
      $clients = enumerate_users_group($_GET['gid'],true);
				      }
  if ($_GET['all_techs']) {
      $techs = enumerate_users(false);
  } else {
      $techs = enumerate_users_group($_GET['gid'],false);
  }
  //////

  $issue_clients = $issue->clients();
  $issue_techs = $issue->techs();

  $_ENV['tpl']->assign('add_clients', $clients);
  $_ENV['tpl']->assign('del_clients', $issue_clients);
  $_ENV['tpl']->assign('add_techs', $techs);
  $_ENV['tpl']->assign('del_techs', $issue_techs);

  $_ENV['tpl']->display("issues/subscribers.tpl");
}
?>

