<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['issueid'])) {
	redirect();
}

if (!closed($_GET['issueid']) or !permission_check("cook_date")) {
  $_ENV['error']->push_error(_("You do not have permission to edit issue times."));
  redirect("?module=issues&action=view&issueid=".$_GET['issueid']);
}

if (isset($_POST['submit']) && $_POST['submit'] == "true") {
  $issue = &get_issue($_GET['issueid']);

  // Justification is required for time adjustment.
  $modification_note = $issue->modification_note();
  if (is_null($modification_note) and
      (empty($_POST['modification_note']) or ($_POST['modification_note'] == "Reason for time adjustment"))) {
  	  push_error(_("Justification is required for time modifications"));
  }

  $real_opened = null;
  if (!empty($_POST['real_opened'])) {
    $real_opened = $_ENV['i18n']->parse_datetime($_POST['real_opened']);
  }

  $real_closed = null;
  if (!empty($_POST['real_closed'])) {
    $real_closed = $_ENV['i18n']->parse_datetime($_POST['real_closed']);
  }

  if (!$real_opened) { $_ENV['error']->push_error(_("Must specify the time the issue was opened")); }
  if (!$real_closed) { $_ENV['error']->push_error(_("Must specify the time the issue was closed")); }

  if (!$_ENV['error']->errors_pending()) {
    $issue->real_opened($real_opened);
	  $issue->real_closed($real_closed);
    $issue->modification_note($_POST['modification_note']);
    $issue->adjusted_by(isset($_SESSION['ADMIN_UID']) ? $_SESSION['ADMIN_UID'] : $_SESSION['userid']);
    $issue->modified(time());

    // back to the issue itself
    redirect("?module=issues&action=view&issueid={$_GET['issueid']}");
  }
}

if (can_view_issue($_GET['issueid'])) {
  $links[] = array(
    "txt" => _("Back to Issue"),
    "url" => "?module=issues&action=view&issueid=".$_GET['issueid'],
    "img" => $_ENV['imgs']['back']
  );

  $sql  = "SELECT * ";
  $sql .= "FROM issues ";
  $sql .= "WHERE issueid=? ";
  $stmt = $_ENV['dbi']->prepare($sql);
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['issueid']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
  $issue_row = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
  $result->free();
  $stmt->free();

  // do this both ways (object and database row) for now
  $issue = &get_issue($_GET['issueid']);

  $_ENV['tpl']->assign('issue',$issue_row);
  $_ENV['tpl']->assign('assigned', $issue->assignees());

  $_ENV['tpl']->display("issues/times.tpl");
} else {
  redirect();
}
?>
