<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

$permitted_groups = array();

// Get assign issues permision for user groups
foreach ($_SESSION['groups'] as $permitted_group) {
   if (permission_check("assign_issues",$permitted_group)) { array_push($permitted_groups, $permitted_group); }
}

// Check if user can assign issues in any group
if (count($permitted_groups) < 1) {
    $_ENV['error']->push_error(_("You don't have permission to assign issues in any group. Contact the administrator."));
    redirect();
} 

else {	
    // retrieve needed statuses
    list($registered) = fetch_status(TYPE_REGISTERED);
    $closed = implode(",",fetch_status(array(TYPE_CLOSED,TYPE_AUTO_CLOSED)));

    $permitted_groups = implode(",",$permitted_groups);
 
    // Make sure we have something to sort by
    if (empty($_GET['sort'])) {
      $_GET['sort'] = "status";
    }
    
    $url  = "?module=issues&action=my_assigned$show$reverse";
    $url .= $_GET['showall'] != "true" ? "&showall=true" : "";
    $url .= $_GET['reverse'] != "true" ? "&reverse=true" : "";
    $_ENV['tpl']->assign('url',$url);

    // Assign issue to selected user
    if ($_REQUEST['assign_to']){
	$issue = &get_issue($_POST['issueid']);
        $issue_group = $issue->group($_POST['gid']);	
        if (!$issue_group->first_response()) {
              $issue_group->first_response(time());
         }
    
         if (isset($_POST['assign_to']) && !empty($_POST['assign_to']) && $issue_group->assigned_to() != $_POST['assign_to']) {
            $issue_group->assigned_to($_POST['assign_to']);
            issue_log($_GET['issueid'],sprintf(_("%s assigned to issue for %s"),username($_POST['assign_to']),group_name($_POST['gid'])));
         }
    }
    
    // now show the rest of the issues
    $params = array();
    $sql  = "SELECT i.*,g.assigned_to,g.gid ";
    $sql .= "FROM issues i,issue_groups g";
    $sql .= $_GET['sort'] == "opened_by" ? ",users u " : " ";
    $sql .= "WHERE g.assigned_to IS NULL ";
    $sql .= "AND i.status = ? ";
    $params[] = $registered;
    $sql .= "AND i.status NOT IN ($closed) "; // safe: from fetch_status, above
    $sql .= "AND i.issueid=g.issueid ";
    if (!is_admin()) {
	$sql .= "AND g.gid in ($permitted_groups) ";
    }
    $sql .= "AND ((select true from  group_unnasigned where gid = g.gid) is not true ";
    $sql .= "OR (select show_group from  group_unnasigned where gid = g.gid) = 't')";
    
    $sort = preg_replace('/[^a-zA-Z0-9]/', '_', $_GET['sort']); // sanitize
    switch ($_GET['sort']) {
    	case "opened_by":
    		$sql .= "AND u.userid=t.$sort DESC ";
    		$sql .= "ORDER BY u.username ";
    		break;
    	default:
    		$sql .= "ORDER BY i.$sort DESC ";
    		break;
    }
    $stmt = $_ENV['dbi']->prepare($sql);
    $result = $stmt->execute($params);
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();
    unset($params);
    
    foreach ($issues as $issuefull) {
       $sql  = "select u.userid, u.username from users u, group_users g ";
       $sql .= " where g.gid = ? ";
       $params[] = $issuefull['gid'];
       $sql .= " and u.userid = g.userid and u.active ='t'";
       $stmt = $_ENV['dbi']->prepare($sql);
       $result = $stmt->execute($params);
       $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
       $users[] = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
       $result->free();
       $stmt->free();
       unset($params);
    }

    $num_rows = count($issues);
    $total = $num_rows;
    //$title = _("My Issues (Assigned) :: Issues");
    //$title = _("My Issues (Assigned) :: Issues ")." ( ".sprintf(_("%s"), $num_rows)." )";
    //
    //
$title = _("Issues Unassigned :: Issues ")." ( ".sprintf(_("%s"), $num_rows)." )";
$colspan = (count($_SESSION['prefs']['show_fields']) >= 13) ? 13 : count($_SESSION['prefs']['show_fields'])+5;
    // Send current date to template, used in due date column
    $_ENV['tpl']->assign('now',time());
    $_ENV['tpl']->assign('colspan',$colspan);
    $_ENV['tpl']->assign('title',$title); 
    $_ENV['tpl']->assign('issues',$issues);
    $_ENV['tpl']->assign('users',$users);
    $_ENV['tpl']->display("issues/unassigned.tpl");
}
?>
