<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['gid']) and !empty($_POST['gid'])) {
  $_GET['gid'] = $_POST['gid'];
}

// fetch "Registered" status
list($registered) = fetch_status(TYPE_REGISTERED);
$closed = fetch_status(array(TYPE_CLOSED,TYPE_AUTO_CLOSED));

$issue = &get_issue($_GET['issueid']);

// Error Checking
if ($issue->status() == $registered and (!isset($_POST['new_status']) or $_POST['new_status'] == "")) {
	$_ENV['error']->push_error(_("Please update the status of this issue."));
}

if (isset($_POST['dur']) and $_POST['dur'] != "" and !ereg("([0-9]+|[0-9]{1,3}\.[0-9]+)",$_POST['dur'])) {
	$_ENV['error']->push_error(_("Please enter a valid duration. (#.##)"));
}
if (isset($_FILES['upload']['name'])) {
  $upload = $_FILES['upload'];  
  $size = round((_MAXUPLOAD_ / 1024) / 1024,2);
    
  if ($upload['size'] > _MAXUPLOAD_ and !is_admin($_SESSION['userid'])) {
		$_ENV['error']->push_error(sprintf(_("Attached file exceeds size limit (%s MB)."), $size));
  }
}
if (empty($_GET['gid'])) {
	$_ENV['error']->push_error(_("You either do not have permission to update this issue or did not choose a group."));
}
if ($_ENV['config']['limits']['max_event']) {
  if (strlen($_POST['event']) > $_ENV['config']['limits']['max_event'] and $_ENV['config']['limits']['max_event'] != 0) {
    $_ENV['error']->push_error(sprintf(_("Your event exceeds the maximum accepted length of %s characters."), number_format($_ENV['config']['limits']['max_event'])));
    $_ENV['error']->push_error(_("Please attach the event as a file."));
  }
}

// Update issue if no errors
if(!$_ENV['error']->errors_pending()){
  // Escalation
  if(!empty($_POST['egid'])){
    $issue->escalate($_POST['egid']);
  }
  
  // Group re-assignment
  if(!empty($_POST['reassign'])){
    $old_gid = $issue->primary_gid();
    $new_gid = $_POST['reassign'];

    if ($old_gid != $new_gid) {
      $old_name = group_name($old_gid);
      $new_name = group_name($new_gid);

      // delete all groups except the new one
      $old_groups = $issue->enumerate_groups();
      $new_gid_found = FALSE;
      foreach ($old_groups as $gid) {
        if ($gid == $new_gid) {
          $new_gid_found = TRUE;
        } else {
          $issue->remove_group($gid);
        }
      }

      // add it to the new one if necessary
      if (!$new_gid_found) {
        $issue_group = $issue->add_group($new_gid);
        $issue_group->opened(time());
        $issue_group->show_issue(TRUE);
      }

      // Change the primary GID for the issue
      $issue->primary_gid($new_gid);

      // And record the move
      issue_log($_GET['issueid'],sprintf(_("Issue moved to %s from %s"), $old_name, $new_name));
    }
  } else {
    // Changes regarding the 'current' gid
    $gid = $_GET['gid'];
    if (!$gid) { $gid = $issue->primary_gid(); }

    // Get the IssueGroup object, adding a new one if necessary
    $issue_group = $issue->group($gid);
    if (!$issue_group) {
      $issue_group = $issue->add_group($gid);
    }

    // Update the first response timestamp if it's not already set
    if (!$issue_group->first_response()) {
      $issue_group->first_response(time());
    }

    // Change the assignment if necessary
    if (isset($_POST['assign']) && !empty($_POST['assign']) && $issue_group->assigned_to() != $_POST['assign']) {
      $issue_group->assigned_to($_POST['assign']);
      issue_log($_GET['issueid'],sprintf(_("Assigned to %s in group %s"),ident($_POST['assign']),group_name($gid)));
    }
  }

  // get the group object
  $group = &get_group($issue->primary_gid());

  if (isset($_POST['cat']) and !empty($_POST['cat']) and $_POST['cat'] != $issue->category()) {
    $issue->category($_POST['cat']);
    issue_log($_GET['issueid'],sprintf(_("Category set to: %s"),category($_POST['cat'])));
  }

  if (isset($_POST['prod']) and !empty($_POST['prod']) and $_POST['prod'] != $issue->product()) {
    $issue->product($_POST['prod']);
    issue_log($_GET['issueid'],sprintf(_("Product set to: %s"),product($_POST['prod'])));
  }

  if (isset($_POST['new_status']) and !empty($_POST['new_status']) and $_POST['new_status'] != $issue->status()) {
    $issue->status($_POST['new_status']);
    issue_log($_GET['issueid'],sprintf(_("Status set to: %s"),status($_POST['new_status'])));

    // record the closing time if the issue has been closed
    if (in_array($_POST['new_status'], $closed)) {
			$issue->closed(time());
		}
  }

  if (isset($_POST['new_istatus']) and !empty($_POST['new_istatus']) and $_POST['new_istatus'] != $issue->istatus()) {
    $issue->istatus($_POST['new_istatus']);
    issue_log($_GET['issueid'],sprintf(_("Internal status set to: %s"),status($_POST['new_istatus'])),TRUE);
  }

  if (isset($_POST['severity']) and !empty($_POST['severity']) and $_POST['severity'] != $issue->severity()) {
    $issue->severity($_POST['severity']);
    issue_log($_GET['issueid'],sprintf(_("Severity set to: %s"),severity_text($_POST['severity'])));
  }

  if (isset($_POST['iseverity']) and !empty($_POST['iseverity']) and $_POST['iseverity'] != $issue->iseverity()) {
    $issue->iseverity($_POST['iseverity']);
    issue_log($_GET['issueid'],sprintf(_("Internal severity set to: %s"),severity_text($_POST['iseverity'])),TRUE);
  }

  $private  = (isset($_POST['tprivate']) and $_POST['tprivate']) == "on";
  $issue->is_private($private);

  // record the modification time unconditionally
  $issue->modified(time());
  
  // handle an uploaded file
  $fids = array();
  if (!empty($_FILES['upload']['name'])) {
    $fids = upload($_GET['issueid']);
  }

  //Fixed 7/20/2004: Failing to query (i,u,d) the database.
  //Check for and store values from group-defined fields.
  if (isset($_SESSION['custom_fields']) && is_array($_SESSION['custom_fields']) && count($_POST) > 0) {
     foreach ($_SESSION['custom_fields'] as $gfid => $info) {
         $stmt = $_ENV['dbi']->prepare("SELECT count(*) from issue_group_fields where issueid=? and gfid=?");
         $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
         $result = $stmt->execute(array($_GET['issueid'], $gfid));
         $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
         $count = $result->fetchOne(); 
         $result->free();
         $stmt->free();
         if($count > 0){
 	    //Update or delete.
            if(array_key_exists($info['name'], $_POST) && !empty($_POST[$info['name']])){
	         $update = array();
	         $types = array();
	         if(substr($info['type'], 0, 6) == "select"){
	              $update['value_idx'] = $_POST[$info['name']];
	              $types[] = 'integer';
	         } else {
	              $update['value'] = $_POST[$info['name']];
	              $types[] = 'text';
	         }
	         $result = $_ENV['dbi']->extended->autoExecute("issue_group_fields",
	                      $update, MDB2_AUTOQUERY_UPDATE,
	                      sprintf("issueid=%s and gfid=%s", 
	                      $_ENV['dbi']->quote($_GET['issueid'], 'integer'),
	                      $_ENV['dbi']->quote($gfid, 'integer')),
	                      $types); 
	         $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	    } else {
                 $result = $_ENV['dbi']->extended->autoExecute("issue_group_fields",
		               null,
		               MDB2_AUTOQUERY_DELETE,
		               sprintf("issueid=%s and gfid=%s", 
		 $_ENV['dbi']->quote($_GET['issueid'], 'integer'), 
		 $_ENV['dbi']->quote($gfid, 'integer'))); 
	         $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	   }
	 } else {
	   // Insert
	   if(array_key_exists($info['name'], $_POST) && !empty($_POST[$info['name']])){
	       $insert = array();
	       $types = array();
	       $insert['issueid']  = $_GET['issueid'];
	       $types[] = 'integer';
	       $insert['gfid']             = $gfid;
	       $types[] = 'integer';
	       if(substr($info['type'], 0, 6) == "select") {
	            $insert['value_idx'] = $_POST[$info['name']];
	            $types[] = 'integer';
	       }else {
	            $insert['value'] = $_POST[$info['name']];
	            $types[] = 'text';
	       }
               $result = $_ENV['dbi']->extended->autoExecute("issue_group_fields",
                        $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
                        $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
           }
	 }
    }
    unset($_SESSION['custom_fields']);
  }
  //End group-defined fields block.

  // create an event, if there was any action texe
  if (trim($_POST['event']) != "") {
    // grab the first fid if there are several, to attach to the event
    $fid = null;
    if (sizeof($fids)) { $fid = $fids[0]; }

    $duration = "0.00";
    if (!empty($_POST['hours']))
	$duration = $duration + $_POST['hours'];
    if (!empty($_POST['minutes']))
        $duration = $duration + ($_POST['minutes']/60);


    $evt = $issue->add_event(
        $_POST['event'],
        $_SESSION['userid'],
        $issue->status(),
        $duration, // duration
        ((isset($_POST['eprivate']) and $_POST['eprivate'] == "on") or ($_GET['gid'] != $_POST['ogid'])), // private
        $fid, null, $_GET['gid']);

    // now add this user as a tech or client on the issue
    if ($group->is_tech($_SESSION['userid'])) {
      $issue->add_tech($_SESSION['userid']);
    } else {
      $issue->add_client($_SESSION['userid']);
    }

  }

  unset($_POST);
}

// We call get_issue() once in no_cache mode
// so that the cache will be updated for any
// later callers.
get_issue($_GET['issueid'], false);

include_once(_MODULES_."issues/view.issues.php");
?>
