<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if (empty($_GET['issueid']) || !is_numeric( $_GET['issueid'] ) ) {
  redirect();
}

$issue = &get_issue($_GET['issueid']);

if( !$issue ) {
    redirect();
}

// handle getting a URL without a GID
if (empty($_GET['gid'])) {
  // if we have it from a POST (from choose_view_group.issue.php), use that
  if (!empty($_POST['gid'])) {
    $gid = $_POST['gid'];
    $_GET['gid'] = $gid;
//    redirect("?module=issues&action=view&issueid={$_GET['issueid']}&gid=$gid");
  } else {
    // if this is a simple issue with only one group, use that
    $issue_gids = $issue->enumerate_groups();
    if (count($issue_gids) < 2) {
      if ($issue_gids) { $gid = $issue_gids[0]; }
      else { $gid = $issue->primary_gid(); }

      $_GET['gid'] = $gid;
//      redirect("?module=issues&action=view&issueid={$_GET['issueid']}&gid=$gid");
    } else {
      // otherwise, go to another page to choose the right group
      redirect("?module=issues&action=choose_view_group&issueid={$_GET['issueid']}");
    }
  }
}

// we have a group now, so get the object
$group_obj = &get_group($_GET['gid']);

////
// Process (some) form submissions (remainder are processed in update.issue.php)

// due date update
// Bug #10310 (Gridshield Tracker) - Fixed by Oscar Retana (2008.07.03)
if (isset($_GET['update_duedate']) and is_group_admin($group_obj->gid())) {
	$due_date = $_ENV['i18n']->parse_datetime($_POST['duedate']);
	if (!$due_date) {
		if (is_null($due_date)) {
			$issue->due_date(null);
			issue_log($_GET['issueid'],_("Due date removed"));
		} else {
			$_ENV['error']->push_error(_("Incorrectly formatted due date"));
		}
	} else {
		$issue->due_date($due_date);
		$due_date_log = $_ENV['i18n']->format_datetime($due_date);
		issue_log($_GET['issueid'],sprintf(_("Due date set to: %s"), $due_date_log));
	}
}

// event privacy
if (!empty($_GET['eid'])) {
  $event = $issue->event($_GET['eid']);
  if (!$event) {
    $_ENV['error']->push_error(_("No such event."));
  } else {
    $private = $_GET['type'] == "private";
    $_ENV['error']->logger("Event ".$_GET['eid']." for issue ".$_GET['issueid']." set to ".$_GET['type'],"privacy");
    $event->is_private($private);
  }
}

// summary
if (isset($_GET['update_summary']) and issue_priv($_GET['issueid'],"technician") and !empty($_POST['summary'])) {
	$summary_modified = $_POST['summary'];
	$issue->summary($summary_modified);
	issue_log($_GET['issueid'],sprintf(_("Summary set to: %s"), $summary_modified));
}

////
// Process toolbar buttons

// reopen
if (!empty($_GET['reopen'])){
     	$issue->reopen();
}

// de-escalate
if (!empty($_GET['gid']) and isset($_GET['deescalate'])) {
	$issue->deescalate($_GET['gid']);
}

// subscription
if (!empty($_GET['toggle_subscribe'])) {
  // first, if they are a tech or a client, remove them
  if ($issue->is_tech($_SESSION['userid'])) {
    $issue->remove_tech($_SESSION['userid']);
  } elseif ($issue->is_client($_SESSION['userid'])) {
    $issue->remove_client($_SESSION['userid']);

  // otherwise, they're not already subscribed, so look
  // up the user with the group, and make the right kind of
  // subscription.
  } else {
    if ($group_obj->is_tech($_SESSION['userid'])) {
      $issue->add_tech($_SESSION['userid']);
    } elseif ($group_obj->is_client($_SESSION['userid'])) {
      $issue->add_client($_SESSION['userid']);
    }
  }
}

if (can_view_issue($_GET['issueid'])) {
  $stmt = $_ENV['dbi']->prepare("SELECT * FROM issues WHERE issueid=?");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute(array($_GET['issueid']));
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
  $issue_row = $result->fetchRow(MDB2_FETCHMODE_ASSOC); 
  $result->free();
  $stmt->free();
  $_ENV['tpl']->assign('issue',$issue_row);

   update_view_tracking($_GET['issueid']);

    $group = $_GET['gid'];

    if (issue_priv($_GET['issueid'],"technician")) {
      $links[] = array(
        "txt" => _("Email Issue"),
        "url" => "?module=issues&action=email&issueid=".$_GET['issueid']."&gid=$group",
        "img" => $_ENV['imgs']['email']
      );
    }
  
    if (closed($_GET['issueid'])) {
      $links[] = array(
        "txt" => _("Reopen Issue"),
        "url" => "?module=issues&action=view&issueid=".$_GET['issueid']."&gid=$group&reopen=true",
        "img" => $_ENV['imgs']['show_closed']
      );
    }

    if (show_issue($_GET['issueid'],$group)
    and permission_check("technician",$group)
    and $group != $issue_row['primary_gid']) {
      $links[] = array(
        "txt" => _("De-Escalate Issue"),
        "url" => "?module=issues&action=view&deescalate=true&issueid=".$_GET['issueid']."&gid=".$_GET['gid'],
        "img" => $_ENV['imgs']['deescalate']
      );
    }

    $is_subscribed = $issue->is_client($_SESSION['userid']) || $issue->is_tech($_SESSION['userid']);
    $links[] = array(
      "txt" => $is_subscribed ? _("Unsubscribe") : _("Subscribe"),
      "url" => "?module=issues&action=view&issueid=".$_GET['issueid']."&gid=$group&toggle_subscribe=true",
      "img" => $is_subscribed ? $_ENV['imgs']['unsubscribe'] : $_ENV['imgs']['subscribe']
    );

    $links[] = array(
      "txt" => _("Issue Files"),
      "url" => "?module=issues&action=files&issueid=".$_GET['issueid'],
      "img" => $_ENV['imgs']['file']
    );

    $links[] = array(
      "txt" => _("Issue Log"),
      "url" => "?module=issues&action=view_log&issueid=".$_GET['issueid'],
      "img" => $_ENV['imgs']['issue_log']
    );

    $links[] = array(
      "txt" => _("Edit Subscriptions"),
      "url" => "?module=issues&action=subscribers&issueid=".$_GET['issueid']."&gid=".$_GET['gid'],
      "img" => $_ENV['imgs']['edit']
    );

    if (issue_priv($_GET['issueid'],"move_issues")) {
      $links[] = array(
        "txt" => _("Move Issue"),
        "url" => "?module=issues&action=move_issue&issueid=".$_GET['issueid'],
        "img" => $_ENV['imgs']['move']
      );
    }

    $links[] = array(
      "txt" => _("Copy Issue"),
      "url" => "?module=issues&action=new&gid=" . $group . "&icopy=".$_GET['issueid'],
      "img" => $_ENV['imgs']['move']
    );
    
    if (closed($_GET['issueid']) and permission_check("cook_date")) {
      $links[] = array(
        "txt" => _("Modify Open/Close Times"),
        "url" => "?module=issues&action=times&issueid=".$_GET['issueid'],
        "img" => $_ENV['imgs']['cook']
      );
    }

    $_ENV['tpl']->assign('clients', $issue->clients());
    $_ENV['tpl']->assign('techs', $issue->techs());

    $assignees = $issue->assignees();
    $_ENV['tpl']->assign('assignees',$assignees);

    $assigned = array_key_exists($_GET['gid'], $assignees)?$assignees[$_GET['gid']]:null;
    $_ENV['tpl']->assign('assigned',$assigned);

    // Show number of files attached to the issue
    $sql  = "SELECT count(fid) from files "; # changeid: 1
    $sql .= "WHERE typeid = ? and file_type ='issues'";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($_GET['issueid']));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $files = $result->fetchOne(); 
    $result->free();
    $stmt->free();
    $_ENV['tpl']->assign('files',$files);

    $sql  = "SELECT eid,performed_on,action,userid,duration,fid,private ";
    $sql .= "FROM events ";
    $sql .= "WHERE issueid=? ";
    $sql .= !issue_priv($_GET['issueid'],"view_private") ? "AND private != 't' " : "";
    $sql .= "ORDER By performed_on DESC";
    $stmt = $_ENV['dbi']->prepare($sql);
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute(array($_GET['issueid']));
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    $events = $result->fetchAll(MDB2_FETCHMODE_ASSOC); 
    $result->free();
    $stmt->free();

    $num_events = count($events);
    $user_editevents_issue = issue_priv($_GET['issueid'],"edit_events"); # changeid: 2
    $user_view_private_issue = issue_priv($_GET['issueid'],"view_private"); # changeid: 3
    $user_is_admin = is_admin(); # changeid: 4
    $user_is_employee = is_employee(); # changeid: 5
    $show_duration = issue_priv($_GET['issueid'],"technician");

    $usernames = array();

    for ($x = 0;$x < $num_events;$x++) {
      // assign username from the usernames hash if not in there obtain it from the database
      if (empty($usernames[$events[$x]['userid']])) {
        $usernames[$events[$x]['userid']] = ident($events[$x]['userid']);
      }
      $events[$x]['username'] = &$usernames[$events[$x]['userid']];

      if (!empty($events[$x]['fid'])) {
        $events[$x]['links'][] = array(
          'img' => $_ENV['imgs']['file'],
          'alt' => _("Download File"),
          'url' => '?module=download&fid='.$events[$x]['fid']
        );
      }
      
      if ($events[$x]['userid'] == $_SESSION['userid']
      or $user_editevents_issue ) { // changeid: 2
	 if (!$_ENV['config']['features']['disable_edit_admin']) { 
	   if (!$_ENV['config']['features']['disable_edit'] or ($_ENV['config']['features']['disable_edit'] and $user_is_admin)) {  // changeid: 4
          $events[$x]['links'][] = array(
            'img' => $_ENV['imgs']['edit'],
            'alt' => _("Edit Event"),
            'url' => '?module=issues&action=edit&issueid='.$_GET['issueid'].'&gid='.$issue_row['primary_gid'].'&eid='.$events[$x]['eid']
          );
	  }
	}
      }

      if ($user_is_employee and $user_view_private_issue) { // changeid: 3 & changeid: 5
        $url = "?module=issues&action=view&issueid=".$_GET['issueid']."&eid=".$events[$x]['eid']."&gid={$_GET['gid']}";

        $events[$x]['links'][] = array(
          'img' => $events[$x]['private'] == "t" ? $_ENV['imgs']['private'] : $_ENV['imgs']['public'],
          'alt' => $events[$x]['private'] == "t" ? _("Make Event Public") : _("Make Event Private"),
          'url' => $events[$x]['private'] == "t" ? $url."&type=public" : $url."&type=private"
        );
      }
     
      $events[$x]['class'] = $events[$x]['private'] == "t" ? "private" : "data";
    }
    $_ENV['tpl']->assign('show_duration', $show_duration);
    $_ENV['tpl']->assign('events',$events);
    $_ENV['tpl']->display("issues/view.tpl");	
    
    // Try this for checking issue visibility.
    if(isset($_GET['rw']) && $_GET['rw'] == 0){
      exit;
    }
    
    if (!closed($_GET['issueid']) and issue_priv($_GET['issueid'],"create_issues")) {
      $statuses = issue_statuses($_GET['issueid']);
      $_ENV['tpl']->assign('group',$group);
      $_ENV['tpl']->assign('statuses',issue_statuses($_GET['issueid']));
      $_ENV['tpl']->assign('istatuses',issue_istatuses($_GET['issueid']));
      //Added: products by Dave Joyce <david.joyce@timco.aero>
      $_ENV['tpl']->assign('products',issue_products($_GET['issueid']));
      $_ENV['tpl']->assign('categories',issue_categories($_GET['issueid']));	  
      $imembers = issue_members($_GET['issueid']);
      $gmembers = group_members($group);
      //Added 07/01/2004: assign_groups
      $gassigns = group_assigns($group);
      $_ENV['tpl']->assign('members',$imembers);
      $_ENV['tpl']->assign('gmembers',$gmembers);
      $_ENV['tpl']->assign('familygroups', $gassigns);
      $_ENV['tpl']->assign('notifylist',is_employee($_SESSION['userid']) ? $imembers : $gmembers);
      $_ENV['tpl']->assign('egroups',escalation_groups($group));
      
      //Added 07/12/2004: Get & parse group-defined fields, if any.
      $fields = group_fields($group);
      $custom_fields = "";
      foreach ($fields as $gfid => $field) {
      	$_SESSION['custom_fields'][$gfid] = array('name' => $field['name'], 'type' => $field['type']);
      	$_ENV['tpl']->assign("label", $field['label']);
      	$_ENV['tpl']->assign("name", $field['name']);
      	switch ($field['type']) {
      	  case "select":
      	  case "select multiple":
      	    $value_arr = group_field_values($gfid);
      	    $values = array();
      	    if(!is_null($value_arr)){
      	      foreach($value_arr as $idx => $arr){
      	      	$values[$idx] = $arr['value'];
      	      	if($arr['default'] == "t"){
      	      	  $def_value = $idx;
      	      	}
      	      }
      	      $_ENV['tpl']->assign("values", $values);
      	      $curr_value = issue_group_field_value($gfid, $_GET['issueid']);
      	      if(!empty($curr_value)){
      	      	$def_value = $curr_value;
      	      }
      	      $_ENV['tpl']->assign("def_value", $def_value);
      	      $custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
      	    }
      	    break;
      	  case "checkbox":
      	  case "date":
      	  case "text":
      	  case "textarea":
      	  	$value_arr = group_field_values($gfid);
      	  	$curr_value = issue_group_field_value($gfid, $_GET['issueid']);
      	  	if (!empty($curr_value)) {
      	  	  $_ENV['tpl']->assign("value", $curr_value);
      	  	} elseif (!empty($value_arr[0]['value'])) {
      	  	  $_ENV['tpl']->assign("value", $value_arr[0]['value']);
      	  	}
      	  	$custom_fields .= $_ENV['tpl']->fetch($field['tpl']);
      	  	break;
	} 
        $_ENV['tpl']->clear_assign(array("label","name","value","values","def_value"));
        unset($value_arr);
      	unset($curr_value);
      }
      $_ENV['tpl']->assign("custom_fields", !empty($custom_fields) ? $custom_fields : null);
      //End group-defined fields block.
      
      $_ENV['tpl']->display("issues/new_event.tpl");
    }
    $_ENV['tpl']->display("issues/show_events.tpl");

} else {
	$_ENV['error']->push_error(_("Could not find that issue in the database."));
	redirect();
}
?>
