<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

$user = &get_user($_SESSION['userid']);
if (!$user) { die("No such user as you!"); } // ?!

if ($_POST) {
  // first, parse up the form
  $add_emails = array();
  var_dump($_POST['add_emails']);
  if (isset($_POST['add_emails']) && trim($_POST['add_emails'])) {
    foreach (explode("\n", trim($_POST['add_emails'])) as $email) {
      $add_emails[] = trim($email);
    }
  }

  $del_emails = array();
  if (isset($_POST['del_emails'])) {
    $del_emails = $_POST['del_emails'];
  }

  // do some sanity-checking
  foreach ($add_emails as $email) {
    // be fairly liberal in what we allow..
    if (!preg_match("/^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9.-]+$/", $email)) {
      $_ENV['error']->push_error(sprintf(_("Invalid email address '%s'."), $email));
    }
  }

  // are we deleting them all?
  if (sizeof($del_emails) && sizeof($del_emails) == sizeof($user->alternate_emails())) {
    $_ENV['error']->push_error(_("Cannot delete all email addresses -- you must have at least one email address.  To change your address, first add and verify your new address, then delete the old address."));
  }

  // do the actual manipulations
  if (!$_ENV['error']->errors_pending()) {
    // add first, then delete
    foreach ($add_emails as $email) {
      send_email_verification($email,
          sprintf(_("Click on the http link below to activate your new email address,\n  %s"), $email),
          "activate_email", array("email" => $email, "userid" => $_SESSION['userid']));
    }

    foreach ($del_emails as $email) {
      $user->delete_email($email);
    }

    if ($add_emails) {
      $_ENV['tpl']->assign("add_emails", $add_emails);
      $_ENV['tpl']->display("prefs/email.prefs-changed.tpl");
      exit;
    }
  }

  //redirect("?action=email&module=prefs");
}

$_ENV['tpl']->assign('alternate_emails',$user->alternate_emails());
$_ENV['tpl']->display("prefs/email.prefs.tpl");
