<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

// disable themes/colors link if global config pref set.
if( isset( $_ENV['config']['features']['disable_edit_themes_and_colors'] ) &&
  $_ENV['config']['features']['disable_edit_themes_and_colors'] == true) {
  print "Module access forbidden.";
  exit;
}


/* Listing all of the fields here makes the code below look better */

$elements = array(
  _("Default") => array(
    "fgcolor" => "fgcolor",
    "bgcolor" => "bgcolor"
  ),
  _("Table Headers") => array(
    "fgcolor" => "table_head_fgcolor",
    "bgcolor" => "table_head_bgcolor"
  ),
  _("Titlebars") => array(
    "fgcolor"  => "titlebar_fgcolor",
    "bgcolor" => "titlebar_bgcolor"
  ),
  _("Sub Titles") => array(
    "fgcolor" => "subtitle_fgcolor",
    "bgcolor" => "subtitle_bgcolor"
  ),
  _("Alternating Row 1") => array(
    "fgcolor" => "row1_fgcolor",
    "bgcolor" => "row1_bgcolor"
  ),
  _("Alternating Row 2") => array(
    "fgcolor" => "row2_fgcolor",
    "bgcolor" => "row2_bgcolor"
  ),
  _("Label Cells") => array(
    "fgcolor" => "label_fgcolor",
    "bgcolor" => "label_bgcolor"
  ),
  _("Data Cells") => array(
    "fgcolor" => "data_fgcolor",
    "bgcolor" => "data_bgcolor"
  ),
  _("Menu Items") => array(
    "fgcolor" => "menu_fgcolor",
    "bgcolor" => "menu_bgcolor"
  ),
  _("Submenu Items") => array(
    "fgcolor" => "submenu_fgcolor",
    "bgcolor" => "submenu_bgcolor"
  ),
  _("Error Messages") => array(
    "fgcolor" => "error_fgcolor",
    "bgcolor" => "error_bgcolor"
  )
);

$parameters = array(
  'font_size',
  'font_unit',
  'font_family',
  'border_color',
  'link_hover',
  'underline',
);

/* Load up the theme file, if it exists */
$theme = $_SESSION['theme'] or 'default';
$themefile = _THEMES_."$theme/theme.php";
if (file_exists($themefile)) {
  include($themefile);
}

/* Load up the user's prefs -- we'll need them. */
/* specify defaults if none are found */
// XXX are these in the session?  whatever.
$user_prefs = array_merge(get_theme_settings(), user_preferences());

/* we use an extra integer in the URL for our user style CSS.
 * So long as this integer doesn't change, browsers will use the
 * cached version; when we change it, the browser will see a new, distinct
 * URL, and will re-fetch the data.
 */
function increment_style_counter()
{
  if (!isset($_SESSION['stylecounter'])) {
    $_SESSION['stylecounter'] = 0;
  }
  $_SESSION['stylecounter']++;
}

/* get down to work */

if (isset($_GET['reset'])) {
  foreach ($elements as $key => $val) {
    unset_user_preference($val['fgcolor']);
    unset_user_preference($val['bgcolor']);
  }

  foreach ($parameters as $name) {
    unset_user_preference($name);
  }

  increment_style_counter();
  redirect("?module=prefs&action=style");
}

if (isset($_GET['submit'])) {
  /* make an array of 'preference' => new value; then we'll check them against the current
   * prefs and issue any required updates. */
  $fields = array();
  foreach ($elements as $key => $val) {
    $fields[$val['fgcolor']] = $_POST['style_'.$val['fgcolor']];
    $fields[$val['bgcolor']] = $_POST['style_'.$val['bgcolor']];
  }
  foreach ($parameters as $name) {
    $field_name = 'style_'.$name;
    $fields[$name] = '';
    if (isset($_POST[$field_name])) { $fields[$name] = $_POST[$field_name]; }
  }

  // check that against the prefs
  foreach ($fields as $preference => $value) {
    if (isset($user_prefs[$preference]) && $user_prefs[$preference] != $value) {
      set_user_preference($preference, $value);
    }
  }
  increment_style_counter();

  // TODO: get rid of this
  if (!empty($_POST['imgext'])) {
    set_user_preference('imgext', $_POST['imgext']);
  }

  redirect("?module=prefs&action=style");
} else {
  /* enumerate available themes */
  if ($dir = @opendir(_THEMES_)) {
    $themes = array();

    while (($file = readdir($dir)) !== false) {
      if ($file{0} == "." or $file == ".." or $file == "CVS") {
        continue;
      }

      if (is_dir(_THEMES_.$file)
      and file_exists(_THEMES_.$file."/theme.php")
      and file_exists(_THEMES_.$file."/screen.css")
      and file_exists(_THEMES_.$file."/tpl")
      and is_dir(_THEMES_.$file."/tpl")) {
        $themes[] = $file;
      }
    }
    closedir($dir);
    if (@count($themes) > 1) {
      $_ENV['tpl']->assign('themes',$themes);
      $_ENV['tpl']->display("prefs/themes.tpl");
    }
  }

  /* set up for rendering */

  $links[] = array(
    "txt" => _("Reset to Defaults"),
    "url" => "?module=prefs&action=style&reset=true"
  );
    
  foreach ($parameters as $name) {
    $_ENV['tpl']->assign($name, $user_prefs[$name]);
  }

  foreach ($elements as $key => $val) {
    $values[$val['fgcolor']] = $user_prefs[$val['fgcolor']];
    $values[$val['bgcolor']] = $user_prefs[$val['bgcolor']];
  }

  $_ENV['tpl']->assign('elements',$elements);
  $_ENV['tpl']->assign('values',$values);
  $_ENV['tpl']->display("prefs/style.tpl");
}
?>
