<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!$_ENV['config']['features']['auto_register']) {
  redirect();
}

if (isset($_GET['create'])) {
  if (!isset($_POST['username'])) {
    $_ENV['error']->push_error(_("You must specify a username."));
  }

  if (!isset($_POST['primary_email'])
  or !eregi("^[_.0-9a-z-]+@([0-9a-z][0-9a-z-]+.)+[a-z]{2,4}$",$_POST['primary_email'])) {
    $_ENV['error']->push_error(_("You must specify a valid email address."));
  }

  if (!isset($_POST['password']) or !isset($_POST['confirm'])) {
    $_ENV['error']->push_error(_("You must supply a password and confirmation."));
  } elseif ($_POST['password'] != $_POST['confirm']) {
    $_ENV['error']->push_error(_("Passwords do not match."));
  }

  // test for that username and email already existing
  if (($existing_user = &get_user_by_username($_POST['username']))) {
    $_ENV['error']->push_error(_("That username already exists."));
  }

  if ($existing_user = &get_user_by_email($_POST['primary_email'])) {
    if (!$existing_user->is_email_only()) {
      $_ENV['error']->push_error(_("A user with that email address already exists."));
    }
  }

  if (!$_ENV['error']->errors_pending()) {
    $username = $_POST['username'];
    $password = $_POST['password'];
    $primary_email = $_POST['primary_email'];
    $first_name = isset($_POST['first_name'])?$_POST['first_name']:'';
    $last_name = isset($_POST['last_name'])?$_POST['last_name']:'';

    send_email_verification($primary_email,
      sprintf(_("Follow the link below to activate the account '%s'."), $username),
      "activate_account",
      array(
        "username" => $username,
        "primary_email" => $primary_email,
        "first_name" => $first_name,
        "last_name" => $last_name,
        "password" => $password,
      ));

    $_ENV['error']->push_error(sprintf(_("A verification email has been sent to '%s'.  Please follow the instructions in that email to continue."), $primary_email));

    redirect();
  }
}

$_ENV['tpl']->display("public/register.tpl");
?>     
