<?php

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

# Set Entertrack server home

if (isset ($_ENV['root'])) {
	$root=$_ENV['root'];  # back compatible
} else {

	if (isset ($_SERVER)) {
		$root= ( $_SERVER['HTTPS'] ? "https://" : "http://" );
		$root .= $_SERVER['SERVER_NAME'];
		$root .= $_REQUEST['uri'];
	} else {
		$root= ( $_ENV['HTTPS'] ? "https://" : "http://" );
		$root .= $_ENV['SERVER_NAME'];
		$root .= $_ENV['uri'];
	}
}

$now = time(); // Get current time

if (isset($option)) {
	switch ($option) {
		case "weekly":
			$to=$now + 604800;
			break;
		case "daily":
			$to=$now + 86400;
			break;
		case "all":
			break;
		default:
			die ("Invalid report options");
	}
}

# Get issues owners

$sql =  "SELECT DISTINCT ig.assigned_to, u.username, u.primary_email ";
$sql .= "FROM issue_groups ig JOIN issues i USING (issueid) JOIN users u ON (assigned_to = userid) JOIN statuses s on (i.status = s.sid) ";
$sql .= "WHERE s.status_type NOT IN (".TYPE_CLOSED.",".TYPE_AUTO_CLOSED.") AND ig.assigned_to IS NOT NULL AND u.primary_email is NOT NULL ";
$sql .= ( isset($to) ? "AND i.due_date < $to " : "" );
$sql .= "ORDER BY u.username";

$stmt = $_ENV['dbi']->prepare($sql);
$result = $stmt->execute();
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
$users = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
$result->free();
$stmt->free();

# Get issues by user
foreach ($users as $user) {
	$script_out[]="Getting Open Issues for: {$user['username']}\n";
	$sql  = "SELECT i.issueid, i.severity, g.name, i.summary, i.opened, i.due_date ";
	$sql .= "FROM issue_groups ig JOIN issues i USING (issueid) JOIN groups g USING (gid) JOIN statuses s on (i.status = s.sid) ";
	$sql .= "WHERE s.status_type NOT IN (".TYPE_CLOSED.",".TYPE_AUTO_CLOSED.") AND ig.assigned_to IS NOT NULL AND ig.assigned_to={$user['assigned_to']} ";
	$sql .= ( isset($to) ? "AND i.due_date < $to " : "" );
	$sql .= "ORDER BY i.due_date ";
	
	$stmt = $_ENV['dbi']->prepare($sql);
	$result = $stmt->execute();
	$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
	$issues = $result->fetchAll(MDB2_FETCHMODE_ASSOC);
	$result->free();
	$stmt->free();
	
	$_ENV['tpl']->assign('user',$user);
	$_ENV['tpl']->assign('issues',$issues);
	$_ENV['tpl']->assign('now',$now);
	$_ENV['tpl']->assign('from', $now);
	$_ENV['tpl']->assign('to', $to);
	$_ENV['tpl']->assign('root', $root);
	$_ENV['tpl']->assign('option', $option);
	$_ENV['tpl']->assign('title', $title);
	$_ENV['tpl']->assign('company', $company);
	$output = $_ENV['tpl']->fetch("reports/automatic/duedate.tpl");

	# Send Email to user
	$hdrs = array(	'From'    => $sender,
			'Subject' => "$company Issues report"
		     );
	$crlf = "\n";
	$mime = new Mail_mime($crlf);
	$mime->setHTMLBody($output);
	$body = $mime->get();
	$hdrs = $mime->headers($hdrs);
	$mail =& Mail::factory('mail');
	$mail->send($user['primary_email'], $hdrs, $body);
	$_ENV['error']->logger("Report sent to {$user['primary_email']} - Issues reported ".count($issues),"automaticReports");
	$script_out[]="Report sent to {$user['primary_email']} - Issues reported ".count($issues);
	$script_out[]="<HR>";
}
?>
