<?php
/* $Id: tickets_by_technician.reports.php 401 2008-05-17 18:51:47Z danda $ */
/**
 * @package EnterTrack
 * @subpackage Reports_Module
 */

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

$groups = array();

// Get user permissions, if not admin of any group redirect
if (is_manager()) {
  $stmt = $_ENV['dbi']->prepare("SELECT gid from groups where active='t' order by name");
  $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
  $result = $stmt->execute();
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
  $groups = $result->fetchCol(); 
  $result->free();
  $stmt->free();
} else {
  foreach($_SESSION['groups'] as $group) {      
     if (is_group_admin($group))
	$groups[] = $group;  
  }
  if (empty($groups)) {
    $_ENV['error']->push_error("You don't have permission to run 'Issues By Technician' report.");
    redirect();
    exit;  
  }
}

$issue_fields = array(
    "issueid"   => "Issue Id",
    "gid"	=> "Group Name",
    "category"  => "Category",
    "product"   => "Product",
    "status"    => "Status",
    "severity"  => "Severity",
    "opened"    => "Date Opened",
    "duration"  => "Time Logged"
);

$sort_options = array(
    "ascending"                 => "Ascending",
    "descending"                => "Descending",
);

$export_formats = array(
    "csv"   => "Comma Separated Value (.csv)",
    "xls"   => "Excel Spreadsheet (.xls)"
);

// set the start and end dates
$startDate = null;
if (!empty($_POST['sdate'])) {
  $startDate = $_ENV['i18n']->parse_datetime($_POST['sdate']);
  if (!$startDate) {
    $_ENV['error']->push_error(_("Invalid start date."));
  }
}

$endDate = null;
if (!empty($_POST['edate'])) {
  $endDate = $_ENV['i18n']->parse_datetime($_POST['edate']);
  if (!$endDate) {
    $_ENV['error']->push_error(_("Invalid end date."));
  }
}

// default end to current time
if ($startDate && !$endDate) {
  $endDate = time();
}

if (isset($startDate)) {
    $report->set_date_range($startDate,$endDate);
}

// Get Technicians
$sql  = "SELECT distinct u.userid, u.first_name, u.last_name, u.username ";
$sql .= "FROM users u, issue_groups ig ";
$sql .= "WHERE ig.assigned_to = u.userid "; 
if (!is_manager())
   $sql .= "AND ig.gid in (".implode(",",$groups).")";
$sql .= "ORDER BY u.first_name, u.last_name, u.username ";

$stmt = $_ENV['dbi']->prepare($sql);
$_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
$result = $stmt->execute();
$_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
$techs = $result->fetchAll(MDB2_FETCHMODE_ASSOC);  
$result->free();
$stmt->free();

$groups = array_unique($groups);

$_ENV['tpl']->assign('report', 'Issues by Technician');
$_ENV['tpl']->assign('kind', 'issue');
$_ENV['tpl']->assign('type', 'technician');
$_ENV['tpl']->assign('groups', $groups);
$_ENV['tpl']->assign('issue_fields', $issue_fields);
$_ENV['tpl']->assign('sort_options', $sort_options);
$_ENV['tpl']->assign('export_formats', $export_formats);
$_ENV['tpl']->assign('technicians', $techs);
$_ENV['tpl']->display("reports/custom/group_issues_form.tpl");
?>
