<?php
/**
 * @package EnterTrack
 * @subpackage Reports_Module
 */

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

ignore_user_abort(TRUE);
set_time_limit(_MINUTE_ * 10);

// If we dont have gid(s) to pull information for then we
// can't generate a report
if ($_GET['tech'] == "true" and is_manager()) {
  if (!is_array($_POST['userid'])) {
    $_ENV['error']->push_error(_("You must select at least one user to generate a report for."));
  } 
} else {
  if (empty($_POST['gid'])) {
    $_ENV['error']->push_error(_("You must select a group to generate a report for."));
  }
}

$startDate = null;
if (!empty($_POST['sdate'])) {
  $startDate = $_ENV['i18n']->parse_datetime($_POST['sdate']);
  if (!$startDate) {
    $_ENV['error']->push_error(_("Invalid start date."));
  }
}

$endDate = null;
if (!empty($_POST['edate'])) {
  $endDate = $_ENV['i18n']->parse_datetime($_POST['edate']);
  if (!$endDate) {
    $_ENV['error']->push_error(_("Invalid end date."));
  }
}

// default end to current time
if ($startDate && !$endDate) {
  $endDate = time();
}

if (!$_ENV['error']->errors_pending()) {
  $report = new Reports();
  
  switch($_POST['reportunitoftime'])
  {
      case "day":
         $unitoftime = _DAY_;
         break;
      case "hour":
        $unitoftime = _HOUR_;
        break;
      case "min":
        $unitoftime = _MINUTE_;
        break;
      case "sec":
        $unitoftime = 1;
        break;
  }
  
  $report->set_time_unit($unitoftime);
  
  // Do we need to export the report?
  if ($_POST['export'] == true) {
    $report->set_export(true);
    $report->set_export_options($_POST['export_options']);
    $report->set_export_format($_POST['export_format']);
  }
    
  if (isset($startDate)) {
    $report->set_date_range($startDate,$endDate);
  }
  
  if (isset($_POST['name'])) {
    $report->set_name($_POST['name']);
  }
  
  if (isset($_POST['options'])) {
    $report->set_options($_POST['options']);
  } 
  
  if (isset($_GET['kind'])) {
    $report->set_kind(strip_tags($_GET['kind']));
  }
  
  if (isset($_GET['type'])) {
    $report->set_type(strip_tags($_GET['type']));
  }
  
  if (isset($_POST['issue_fields'])) {
    $report->set_issue_fields($_POST['issue_fields']);
  }
  
  if (isset($_POST['sort_options'])) {
    $report->set_sort_options($_POST['sort_options']);
  }
  
  if (isset($_POST['closed'])) {
    $report->set_closed_issues(true);
  }
  
  // set the type of issue report
  if (isset($_POST['statuses'])) {
    $report->set_issue_selections($_POST['statuses']);
  } elseif (isset($_POST['categories'])) {
    $report->set_issue_selections($_POST['categories']);
  } elseif (isset($_POST['products'])) {
    $report->set_issue_selections($_POST['products']);
  } elseif (isset($_POST['severities'])) {
    $report->set_issue_selections($_POST['severities']);
  }
  
  // set the technicians
  if (isset($_POST['technicians'])) {
    $report->set_technicians($_POST['technicians']);
  }
  
  $report->generate($_POST['gid']);
  
} else {
  /**
   * If we errored then include the reports form again
   */
  include_once(_MODULES_."reports/reports.php");
}
?>
