<?php
/**
 * @package EnterTrack
 * @subpackage Reports_Module
 */

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

if ($_SESSION['group_count'] > 0 or is_manager()) {
  $leftnav_menu[_("Reports")] = array(
    "url"   => "?module=reports",
    "sub"   => array(
    _("Stored Reports") => "?module=reports&action=manage"
    )
  );
  
  $gadmin = false;
  foreach ($_SESSION['groups'] as $group) {
    if (is_group_admin($group)) { $gadmin = true; }
  }
  if ($gadmin === true) {
    $leftnav_menu[_("Reports")]["sub"][_("Modified Time Reports")] = "?module=reports&action=modified";
    
  }
  
  $leftnav_menu[_("Reports")]["sub"][_("Issues Summary")] = "?module=reports";
  $leftnav_menu[_("Reports")]["sub"][_("Group Summary")] = "?module=reports&action=group_summary";
  $leftnav_menu[_("Reports")]["sub"][_("Issues By Group")] = "?module=reports&action=issues";

  /**
   * include issue reports
   * added by Tim Boring (tim -at- timboring dot com) 1/2006
   *
   * The way this piece of code works is this:
   * 1. Open the reports/custom/ dir and read in all the filenames.
   * 2. If the file is not the current (.) or parent (..) directories, does not
   * begin with 'generate', or does not end with '.bak'...
   * 3. Explode the filename on '.' and assign the result to the $r_name array.
   * 4. Take the first element of the $r_name array and run it through strtr()
   * to replace any underscores with spaces (this presumes that filenames for
   * the reporting scripts are in the format of 'my_report.reports.php').
   * 5. Finally, it upper cases each word in $name and sets up the leftnav menu
   * item.
   *
   * TODO: some reports are not available, e.g., 'by technicians' is not 
   * available to non-managers -- those reports should not appear here.
   *
   */
  $reports = array();
  $dir = opendir(_MODULES_."reports/custom/");
  while (false !== ($file = readdir($dir))) {
    if ($file{0} != "." and $file != ".." and !preg_match("/^generate/i", $file) and !preg_match("/.bak$/i", $file) and $file != "CVS") {
        $r_name = explode(".", $file);
        $name = strtr($r_name[0],'_',' ');
		$name = str_ireplace( 'ticket', 'issue', $name );
        $name = ucwords($name);
        $leftnav_menu[_("Reports")]["sub"][_($name)] = "?module=reports&action=custom/$r_name[0]"; 
    }
  } 

  $leftnav_menu[_("Reports")]["sub"][_("User Statistics")] = "?module=reports&action=user_statistics";
  $leftnav_menu[_("Reports")]["sub"][_("Raw Data")] = "?module=reports&action=rawdata";

}
?>
