<?php
/* $Id: tickets_by_technician.reports.php 270 2007-05-20 18:18:54Z djmitche $ */
/**
 * @package EnterTrack
 * @subpackage Reports_Module
 */

if (strpos(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
  exit;
}

// Get user permissions, if not admin of any group redirect
$groups = array();
if( is_admin() ) {
    $stmt = $_ENV['dbi']->prepare("SELECT gid from groups where active='t' order by name");
    $_ENV['error']->check_pear_error($stmt, __FILE__, __LINE__);
    $result = $stmt->execute();
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__);
    $groups = $result->fetchCol(); 
    $result->free();
    $stmt->free();
}
else {
    foreach($_SESSION['groups'] as $group) {      
        if ( is_group_admin($group) || permission_check("technician",$group) ) {
            $groups[] = $group;  
        }
    }
}
if (empty($groups)) {
    $_ENV['error']->push_error( _("You don't have permission to run 'Issues By Group' report.") );
    redirect();
    exit;  
}

$issue_fields = array(
    "issueid"   => "Issue Id",
    "category"  => "Category",
    "product"   => "Product",
    "status"    => "Status",
    "severity"  => "Severity",
    "opened"    => "Date Opened",
    "modified"  => "Date Modified",
    "closed"    => "Date Closed",
    "opened_by" => "Opened By",
    "assigned_to" => "Assigned to",
    "problem"   => "Subject",
);

$event_fields = array(
    "action" => "Event Posted",
    "duration" => "Time Worked"
);    

$sort_options = array(
    "ascending"                 => "Ascending",
    "descending"                => "Descending",
);

$_ENV['tpl']->assign('report', 'Issues');
$_ENV['tpl']->assign('groups', $groups);
$_ENV['tpl']->assign('issue_fields', $issue_fields);
$_ENV['tpl']->assign('event_fields', $event_fields);
$_ENV['tpl']->assign('sort_options', $sort_options);
$_ENV['tpl']->display("reports/issues.tpl");
?>
