<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to edit this user's email addresses."));
  redirect();
}

if(empty($_GET['uid'])) { die("No user specified"); }
$user = &get_user($_GET['uid']);
if (!$user) { die("No such user"); }

if ($user->is_email_only()) {
  redirect("?module=users&action=view&uid=".$_GET['uid']);
}

if ($_POST) {
  // first, parse up the form
  $add_emails = array();
  if (isset($_POST['add_emails']) && trim($_POST['add_emails'])) {
     $temp_emails = explode(' ',preg_replace("/\r*\n/"," ",$_POST['add_emails']));
     foreach ($temp_emails as $email) {
       if ($email != "") 
         $add_emails[] = trim($email);
     }
  }

  $del_emails = array();
  if (isset($_POST['del_emails'])) {
    $del_emails = $_POST['del_emails'];
  }

  // do some sanity-checking
  foreach ($add_emails as $email) {
    // be fairly liberal in what we allow..
    if (!preg_match("/^[a-zA-Z0-9_.-]+@[a-zA-Z0-9.-]+$/", $email)) {
      $_ENV['error']->push_error(sprintf(_("Invalid email address '%s' ."), $email));
    }
  }

  // are we deleting them all?
  if (sizeof($add_emails) == 0 && sizeof($del_emails) == sizeof($user->alternate_emails())) {
    $_ENV['error']->push_error(_("Cannot delete all email addresses -- every user must have at least one email address."));
  }

  // do the actual manipulations
  if (!$_ENV['error']->errors_pending()) {
    // add first, then delete
    foreach ($add_emails as $email) {
      // first see if this email already exists
      $existing_user = &get_user_by_email($email);
      if ($existing_user) {
        if ($existing_user->is_email_only()) {
          echo "join($email)<br>";
          join_users($user->userid(), $existing_user->userid());
        } else {
          $_ENV['error']->push_error(sprintf(_("Email address '%s' already belongs to user '%s'."), $email, $existing_user->username()));
        }
      } else {
        $user->add_new_email($email);
      }
    }

    foreach ($del_emails as $email) {
      $user->delete_email($email);
    }

  redirect("?module=users&action=view&uid=".$_GET['uid']);
  }
}

$_ENV['tpl']->assign('alternate_emails',$user->alternate_emails());
$_ENV['tpl']->display("users/email.users.tpl");
