<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to update this user."));
  redirect();
}

if (isset($_POST['username']) && $_POST['username']) {
  // check if the username is already in use
  $existing_username = &get_user_by_username($_POST['username']);
  if ($existing_username) {
    $_ENV['error']->push_error(sprintf(_("Username '%s' already exists."), $_POST['username']));
  }
}

if(!$_ENV['error']->errors_pending()){
  // get the user object and double-check
  $user = &get_user($_GET['uid']);
  if (!$user) { die("No such user."); }
  if (!$user->is_email_only()) { die("Not an email-only user."); }

  if (isset($_POST['username']) && $_POST['username']) {
    // assign a username to this user
    $update = array();
    $types = array();
    $update["username"] = $_POST['username'];
    $types = 'text';
    $update["password"] = generate_password();
    $types = 'text';
    $update["first_name"] = $_POST['first_name'];
    $types = 'text';
    $update["last_name"] = $_POST['last_name'];
    $types = 'text';
    $result = $_ENV['dbi']->extended->autoExecute("users",
      $update,
      MDB2_AUTOQUERY_UPDATE,
      sprintf("userid=%s", $_ENV['dbi']->quote($_GET['uid'], 'integer')),
      $types); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

    send_new_user_email($_POST['email'], $update['username'], $update['password']);
    redirect("?module=users&action=view&uid=".$_GET['uid']);
  } else if (isset($_POST['join_user']) && $_POST['join_user']) {
    join_users($_POST['join_user'], $_GET['uid']);
    // redirect to the full user we just joined
    redirect("?module=users&action=view&uid=".$_POST['join_user']);
  } else if (isset($_POST['first_name']) || isset($_POST['last_name'])) {
    // just update the first/last name -- don't assign a new username
    $update = array();
    $types = array();
    $update["first_name"] = $_POST['first_name'];
    $types = 'text';
    $update["last_name"] = $_POST['last_name'];
    $types = 'text';
    $result = $_ENV['dbi']->extended->autoExecute("users",
      $update,
      MDB2_AUTOQUERY_UPDATE,
      sprintf("userid=%s", $_ENV['dbi']->quote($_GET['uid'], 'integer')),
      $types); 
    $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    redirect("?module=users&action=view&uid=".$_GET['uid']);
  }
}

?>

