<?php

if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!is_employee()) {
  $_ENV['error']->push_error(_("You do not have permission to update this user."));
  redirect();
}

if (!isset($_GET['uid']) || !$_GET['uid']) {
  redirect("?module=users");
}
$userid = $_GET['uid']+0;

// check for errors
if(empty($_POST['username'])){
	$_ENV['error']->push_error(_("Please enter a username"));
}

if(!$_ENV['error']->errors_pending()) {
  // get the user object
  $user = &get_user($userid);
  if (!$user) {
    $_ENV['error']->push_error(_("No such user."));
    redirect("?module=users");
  }

  // update information
  $update = array();
  $types = array();
  $update["username"] = $_POST['username'];
  $types[] = 'text';

  if((isset($_POST['new_pw'])     && $_POST['new_pw'] != '') || 
     (isset($_POST['confirm_pw']) && $_POST['confirm_pw'] != '')) {
    if($_POST['new_pw']==$_POST['confirm_pw']){
      $user->password(md5($_POST['confirm_pw']));
      $_ENV['error']->push_error(_("Password changed."));
    } else {
      // throw error - passwords don't match
      $_ENV['error']->push_error(_("Passwords don't match."));
    }
  }

  if (in_array($_POST['primary_email'], $user->alternate_emails())) {
    $update["primary_email"] = $_POST['primary_email'];
    $types[] = 'text';
  }

  if (isset($_POST['sms'])) {
    $update["sms"] = $_POST['sms'];
    $types[] = 'text';
  }

  if (isset($_POST['first_name'])) {
    $update["first_name"] = $_POST['first_name'];
    $types[] = 'text';
  }

  if (isset($_POST['last_name'])) {
    $update["last_name"] = $_POST['last_name'];
    $types[] = 'text';
  }

  if (is_admin()) {
    $update["admin"] = ($_POST['admin'] == "on") ? "t" : "f";
    $types[] = 'text';

    // do some notifications
    if(!is_admin($userid) and $_POST['admin'] == "t"){
	    $_ENV['error']->logger("User ".username($userid)." granted admin privileges!","admin");
	    admin_notify("User ".username($userid)." granted admin privileges");
    } else if(is_admin($userid) and $_POST['admin'] == "f"){
	    $_ENV['error']->logger("User ".username($userid)." admin privileges removed","admin");
    }
  }

  if($_POST['employee'] == "on"){
	  group_useradd($userid,_EMPLOYEES_);
  } else if (is_employee()) {
    group_userdel($userid,_EMPLOYEES_);
  }

  $update["active"] = ($_POST['active'] == "on") ? "t" : "f";
  $types[] = 'text';

  // some more notifications
  if($user->active() and $update['active'] == "f"){
	  $_ENV['error']->logger("User ".username($userid)." disabled","users");
  } else if(!$user->active() and $update['active'] == "t"){
	  $_ENV['error']->logger("User ".username($userid)." activated","users");
  }

  $result = $_ENV['dbi']->extended->autoExecute("users",
    $update,
    MDB2_AUTOQUERY_UPDATE,
    sprintf("userid=%s", $_ENV['dbi']->quote($userid, 'integer')),
    $types); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

  $result = $_ENV['dbi']->extended->autoExecute("user_permissions",
    null,
    MDB2_AUTOQUERY_DELETE,
    sprintf("userid=%s", $_ENV['dbi']->quote($userid, 'integer'))); 
  $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 

  if (is_array($_POST['permissions'])) {
    foreach ($_POST['permissions'] as $val) {
      $insert = array();
      $types = array();
      $insert['userid'] = $userid;
      $types[] = 'integer';
      $insert['permid'] = $val;
      $types[] = 'integer';
      $result = $_ENV['dbi']->extended->autoExecute("user_permissions",
        $insert, MDB2_AUTOQUERY_INSERT, null, $types); 
      $_ENV['error']->check_pear_error($result, __FILE__, __LINE__); 
    }
  }

  if(isset($_POST['add_groups'])){
	  foreach($_POST['add_groups'] as $key => $val){
	    group_useradd($userid,$val);
	  }
  }

  if(isset($_POST['del_groups'])){
	  foreach($_POST['del_groups'] as $key => $val){
	    group_userdel($userid,$val);
	  }
  }

  gen_cache("users","userid","username");
}

redirect("?module=users&action=view&uid=".$userid);
