<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!$_ENV['config']['features']['auto_register']) {
  die("Auto-registration is disabled.");
}

if (!($arguments = get_verification_arguments())) {
  $_ENV['error']->push_error(_("Invalid verification information"));
} else {
  // see if this username exists already
  $existing_user = &get_user_by_username($arguments['username']);
  if ($existing_user) {
    $_ENV['error']->push_error(sprintf(_("The username '%s' is already in use."), $arguments['username']));
  }

  // see if this email exists already
  $existing_user = &get_user_by_email($arguments['primary_email']);
  if ($existing_user) {
    if ($existing_user->is_email_only()) {
      // commandeer that (formerly email-only) user
      $existing_user->username($arguments['username']);
      $existing_user->password(md5($arguments['password']));
      $existing_user->first_name($arguments['first_name']);
      $existing_user->last_name($arguments['last_name']);

      if ($_ENV['config']['features']['auto_register_group']) {
        group_useradd($existing_user->userid(), $_ENV['config']['features']['auto_register_group']);
      }
      authenticate($arguments['username'], $arguments['password']);
    } else {
      $_ENV['error']->push_error(sprintf(_("The email address '%' is already in use."), $arguments['primary_email']));
    }
  } else {
    $user = create_user($arguments);
    if (!$user) {
      $_ENV['error']->push_error(_("Error creating new user."));
    }

    if ($_ENV['config']['features']['auto_register_group']) {
      group_useradd($user->userid(), $_ENV['config']['features']['auto_register_group']);
    }
    authenticate($arguments['username'], $arguments['password']);
  }
}
redirect();
