<?php
if (eregi(basename(__FILE__),$_SERVER['PHP_SELF'])) {
  print "Direct module access forbidden.";
	exit;
}

if (!($arguments = get_verification_arguments())) {
  $_ENV['error']->push_error(_("Invalid verification information"));
  redirect();
} else {
  // unpack the arguments
  $userid = $arguments['userid'];
  $email = $arguments['email'];

  // see if this user exists already
  $existing_user = &get_user_by_email($email);
  if ($existing_user) {
    if ($existing_user->is_email_only()) {
      // join 'em
      join_users($userid, $existing_user->userid());

      $_ENV['error']->push_error(sprintf(_("Successfully claimed email address '%s'"), $email));
    } else {
      // (this is not an information leak, because this person just demonstrated ownership of the
      // email address; also, this condition is checked before the email is sent, so this error
      // should be rare)
      $_ENV['error']->push_error(sprintf(_("The email address '%s' already belongs to another username, '%s'."),
            $email, $existing_user->username()));
    }
  } else {
    $user = &get_user($userid);
    $user->add_new_email($email);
    $_ENV['error']->push_error(sprintf(_("Successfully claimed email address '%s'"), $email));
  }

  redirect();
}
