<?php

define("_PATH_",dirname(dirname(__FILE__)));
include(_PATH_."/setup/util/common.php");
include(_PATH_."/setup/util/config.php");

////
// Password handling setup
$config = new Configuration();
if ($config->original_version == 'none') {
  $need_password = false;
} elseif (isset($config->data['db']['pass'])) {
  $need_password = true;
  $setup_password = $config->data['db']['pass'];
} else {
  $need_password = false;
}

/* {{{ Function err */
/**
 * Function to display errors.  Errors are taken from
 * $_SESSION['database']['error'][$key]
 *
 * @param string $key the field name to display the error for
 */
function err($key)
{
  if (isset($_SESSION['error'][$key])) {
    echo "<span class=\"error\">{$_SESSION['error'][$key]}</span>";
  }
}
/* }}} */

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
  $_SESSION['error'] = array();

  // destroy the session if the user clicked "Start Over"
  if (isset($_POST['_start_over'])) {
    session_destroy();

  // otherwise, check the password and go on
  } else {
    if ($need_password) {
      if (isset($_POST['setup_password']) && $_POST['setup_password'] == $setup_password) {
        $_SESSION['authenticated'] = true;
        redirect("tests.php");
      } else {
        $_SESSION['error']['setup_password'] = "The password you entered was incorrect.  Please check and try again.";
        $_SESSION['authenticated'] = false;
      }
    } else { // no password required
      $_SESSION['authenticated'] = true;
      redirect("tests.php");
    }
  }
} else {
  // always destroy the session on a non-POST request
  session_destroy();
  $_SESSION['authenticated'] = false;
}

// Draw the page
page_header("Setup :: Welcome",
  "Welcome to the EnterTrack Setup Wizard");
?>
<?php if ($need_password): ?>
<h2>Setup Password Check</h2>
<p>The EnterTrack setup wizard is requires a password to protect the security of your installation.
You must show that you have access to the files stored on the webserver by providing a piece of
information not available via a web browser.</p>

<p>In the space below, please enter the database password for the installation you are upgrading.</p>

<table width="100%">
<tr><td align="right" width="20%">Setup Password:</td>
    <td width="80%"><input type="password" name="setup_password" size="30" value="<?php echo $S['pass']; ?>">
  <?php err("setup_password"); ?></td></tr>
</table>
<?php else: ?>
<h2>Welcome</h2>
<p>Welcome to EnterTrack!  Click 'Next' to get started with your new installation.</p>
<?php endif; ?>
<?php
navigation_box(TRUE);
page_footer();
?>
