<?php
/*
 * Supporting templates for the install process; we don't use Smarty because
 * it may not be set up or may be malfunctioning.
 */

/* Do session setup common to all setup scripts */

session_name("ET_SETUP");
session_start();

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");

/* no timeout (db operations can take a long time) */
set_time_limit(0);

/* {{{ Function page_header */
function page_header($title, $description)
{ ?>
<html><head>
 <title><?php echo $title; ?></title>
 <link rel="stylesheet" title="Setup Window Dressing" href="setup.css" />
</head>
<body>
<h1 class="title"><?php echo $title; ?></h1>
<div class="page_description"><?php echo $description; ?></div>
<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="POST" enctype="multipart/form-data">
<?php }
/* }}} */

/* {{{ Function navigation_box */
function navigation_box($allow_next) {
  echo "<div class=\"navigation\">\n";
  if ($allow_next) { echo " <input type=\"submit\" value=\"Next\" />\n"; }
  echo " <input type=\"submit\" name=\"_start_over\" value=\"Start Over\" />\n";
  echo "</div>";
}
/* }}} */

/* {{{ Function page_footer */
function page_footer()
{ ?>
</form>
</body>
</html>
<?php }
/* }}} */

/* {{{ Function redirect */
function redirect($script)
{
  // make $script into a full URL
  $url = dirname($_SERVER['SCRIPT_NAME']);
  if (!$url || $url{strlen($url)-1} != '/') {
    $url = "$url/";
  }
  if ($script != 'index.php') {
    $url = $url.$script;
  }

  // Send the proper headers and exit
  header("Location: $url");
  session_write_close();
  exit;
}
/* }}} */

/* {{{ Function step_js */
function step_js()
{ ?>
<script language="JavaScript">
function toggle_step(link)
{
  /* go out two levels to find the step div */
  div = link.parentNode.parentNode;
  if (div.className == 'expanded-step') {
    div.className = 'collapsed-step';
    link.innerHTML = 'expand';
  } else {
    div.className = 'expanded-step';
    link.innerHTML = 'collapse';
  }

  return false;
}
</script>
<?php }
/* }}} */

/* {{{ Function step_header */
function step_header($collapse=false)
{
  echo "<div class=\"" . ($collapse?'collapsed-step':'expanded-step') ."\">\n";
  echo "<div class=\"expand_collapse\"><a href=\"#\" onClick=\"return toggle_step(this);\">" . ($collapse?'expand':'collapse') . "</a></div>\n";
}
/* }}} */

/* {{{ Function step_footer */
function step_footer()
{
 echo "</div>\n";
}
/* }}} */
